<?php
/**
 * Plugin Name: Notifal
 * Plugin URI: https://notifal.com/?utm_source=wp-plugins&utm_campaign=plugin-uri&utm_medium=wp-dash
 * Description: Notifal boosts online store sales by displaying real-time or generating fake purchase alerts, creating a sense of urgency and building trust through social proof.
 * Version: 1.1.1
 * Requires PHP: 7.4
 * License: GPLv2 or later
 * Author: Notifal team
 * Author URI: https://notifal.com/?utm_source=wp-plugins&utm_campaign=author-uri&utm_medium=wp-dash
 * Text Domain: notifal
 * Domain Path: /languages
 */
class Notifal{

    /**
     * root constructor
     *
     * @returns void
     * @version 1.0.0
     */
    public function __construct(){
        self::plugin_constants();
        self::initialize_plugin();
        add_action( 'init', [$this,'load_domain'] );
    }

    /**
     * plugin constants
     *
     * @returns void
     * @version 1.0.0
     */
    public function plugin_constants(){
        define('Notifal_DOMAIN','notifal');
        define('Notifal_VERSION','1.1.1');
        define('Notifal_FILE',__FILE__);
        define('Notifal_DIR',plugin_dir_path(__FILE__));
        define('Notifal_NAMESPACE','Notifal');
        define('Notifal_URL',plugin_dir_url(__FILE__ ));
        define('Notifal_INC',Notifal_DIR.'inc/');
        define('Notifal_BASE', plugin_basename( Notifal_FILE ) );
        define('Notifal_WEBSITE', 'https://notifal.com');

    }

    /**
     * Initialize Notifal Plugin
     *
     * @return void
     * @version 1.0.0
     */
    public function initialize_plugin(){
        require  Notifal_INC . 'plugin.php';
    }


    /**
     * Load text domain
     *
     * @return void
     * @version 1.0.0
     */
    public function load_domain(){
        load_plugin_textdomain( Notifal_DOMAIN, false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
    }
}
new Notifal();