/**
 * Add Notif js
 * @version 1.0.0
 * @type {(function(*, *): *)|jQuery}
 */
var j = jQuery.noConflict();
j(document).ready(function($) {


    /**
     * Check woocommerce is active
     */
    let is_woocommerce_active=add_notif_data.is_woocommerce_active;
    /***
     * general js
     */
    // Pro version
    let is_pro_active=add_notif_data.is_pro_active,
        popup_class='.notifal-pro-feature-popup',
        popup_content='.pro-feature-popup-content',
        popup,popup_message,
        close_pro_popup,pro_element,pro_text_element,template_item,
        pro_class='.notifal-pro-feature',
        pro_text_class='.notifal-pro-text';
    if(empty(is_pro_active)){
        popup = $(popup_class);
        popup_message = $('#pro-feature-text');
        close_pro_popup = $('.popup-close-btn');
        pro_element = $(pro_class);
        pro_text_element = $(pro_text_class);
        close_pro_popup.click(function (){popup.fadeToggle()});
        $('body').prepend(popup);

        let pro_data = [
            [pro_element,'notif-setting-template-item',translated_strings.pro_template_message],
            [pro_text_element,'notif-text-tags',translated_strings.pro_tags_message],

        ]
        function show_popup_callback(a,b,c) {
            a.click(function (){
                let domElement=$(this).get(0).nodeName;
                if(a.hasClass(b)){
                    show_pro_popup(c)
                    if(domElement==='OPTION'){
                        $(this).removeAttr('selected');
                        popup_message.text(translated_strings.pro_options_message+':'+$(this).text());
                    }
                }
            })

        }
        pro_data.forEach(function (item, index){
            show_popup_callback.apply(this, item);
        })

        /**
         * show_popup
         */
        function show_pro_popup(message){
            popup_message.text(message)
            popup.fadeToggle();
        }
    }


    /**** Hide and show message box ***/
    let message_box = $('#notifal-setting-message'),error_flag = false,
        hide_message_box_time=8000;
    function show_error(text){
        message_box.html(text).addClass('notifal-error').slideDown();
        error_flag = true;
    }

    function show_success(text){
        message_box.html(text).addClass('notifal-success').slideDown();
    }

    function hide_message_box(){
        message_box.removeClass('notifal-error notifal-success').slideUp();
    }

    /*** prevent type strinf in input with type number ***/
    $('input[type="number"]').on("keypress", function (evt) {
        if(evt.which===46) return;
        if (evt.which < 48 || evt.which > 57)
        {
            evt.preventDefault();
        }
    });


    /**** show tooltip on hover - icon tooltip ***/
    let tooltip = $('<div class="tooltip-description"></div>').appendTo('body'),
        tooltip_text = $('.tooltip-container');
    tooltip_text.on('mouseenter', function () {
        const description = $(this).data('description');
        tooltip.text(description);
        const offset = $(this).offset();
        const height = $(this).outerHeight();
        tooltip.css({
            top: offset.top + height ,
            left: offset.left,
        });
        tooltip.show();
    });
    tooltip_text.on('mouseleave', function () {
        if (!tooltip.is(':hover')) {
            tooltip.hide();
        }
    });

    tooltip.on('mouseleave', function () {
        tooltip.hide();
    });

        /**
     * Remove duplicate from array
     */
    function unique(list) {
        var result = [];
        $.each(list, function(i, e) {
            if ($.inArray(e, result) == -1) result.push(e);
        });
        return result;
    }



    /**
     * menu section
     *
     * change main menu on click
     *
     * @since 1.0.0
     */
    let main_menu = $('.setting-menu-wrapper a');

    function hide_show_main_menu_content(element,menu_data_action=''){
        if(empty(menu_data_action)){
            main_menu.removeClass('active');
            element.addClass('active');
            let data_action = element.attr('data-action');
            $('.notifal-setting').addClass('notifal-d-none');
            $('#'+data_action).removeClass('notifal-d-none');
        }else{
            $('.notifal-setting').addClass('notifal-d-none');
            $('#'+menu_data_action).removeClass('notifal-d-none');
        }

    }

    main_menu.click(function (){hide_show_main_menu_content($(this),'')})


    let no_selected_products = ['all-products','no-products']

    function hide_if_outside(event){
        var $target = $(event.target);
        if(popup !== undefined){
            if(!$target.closest(popup_content).length && !$target.closest(pro_class).length && !$target.closest(pro_text_class).length) {
                popup.fadeOut();
            }

        }

    }




    $(document).click(function(event) { hide_if_outside(event) });


    /**
     * Visual section
     * Template section
     */
    /*********************** Select Template **********************************/
    let template=$('.notif-setting-template-item'),
        template_preview=$('.notif-setting-template-preview');

    function get_template_on_click(element){
        let template_id= element.attr('id');
        template_preview.find('.template-preview').hide().each(function (){
            if(template_id+'.php'===$(this).attr('data-id')){
                $(this).show();
            }
        });
        let defaults_color = JSON.parse(add_notif_data.default_templates_colors)[template_id];
        $('.notif-option-color-input').each(function (){
            let color_input=$(this).find('input'),
                id=color_input.attr('id').replaceAll('-','_');
            color_input.val(defaults_color[id]).trigger('change');
        });
    }

    template.find('input').click(function (){get_template_on_click($(this))});

    /********************* Text content *************************************/
    let   notif_custom_text = $('.notif-custom-text'),notif_text_tags;
    if(!empty(is_woocommerce_active)){

        notif_text_tags = $('.notif-text-tags')

        function copy_text(text,element){
            let input =$("<input>"),
                results_copy_holder= element.closest('span.tooltip-container').find('span'),
                tooltip_text=results_copy_holder.text();
            $("body").append(input);
            input.val(text).select();
            document.execCommand("copy");
            input.remove();
            results_copy_holder.text(translated_strings.copied_text);
            setTimeout(function (){
                results_copy_holder.text(tooltip_text);
            },1000)
        }
    }


    function change_notif_text(element){
        let text_val=element.val().trim(),
            id=element.attr('id'),
            text_ids=[
              ['custom-main-text','.notifal-main-text'],
              ['first-additional-info-text','.first-additional-info'],
              ['second-additional-info-text','.second-additional-info'],
              ['action-button-text','.action-button-parent']
            ];
        function change_text_callback(a,b) {
            if(id===a){
                $(b).html(text_val);
                if(text_val.indexOf('copy_text')>-1){
                    $(b).html(function (index, html) {
                        return html.replace(
                            /\{copy_text text="([^"]+)" copy_text="([^"]+)"\}/g,
                            function (match, buttonText, copyText) {
                                return `<span class="notif-copy-text" data-copy-text="${copyText}">${buttonText}</span>`;
                            }
                        );
                    });
                }

            }
        }
        text_ids.forEach(function (item, index){
            change_text_callback.apply(this, item);
        })
    }


    notif_custom_text.on('keyup', function (){change_notif_text($(this))});
    if(!empty(is_woocommerce_active)){
        notif_text_tags.click(function (){copy_text($(this).text(),$(this))});
    }


    /********************** Style Live Changer ********************************/

    /****** Display option ******/
    let display_elements = [
        ['#allow-close','.notifal-close,#if-close-notif-holder'],
        ['#first-additional-info','#first-additional-info-text-holder,.first-additional-info '],
        ['#second-additional-info','#second-additional-info-text-holder,.second-additional-info'],
        ['#action-button','.action-button-parent,#actionButton-text-holder']];
    if(!empty(is_woocommerce_active)){
        display_elements.push(['#product-image','.notifal-pulse-img']);
    }
    function display_element_callback(a,b) {
        $(a).click(function (){
            $(b).toggle();
        })
    }
    display_elements.forEach(function (item, index){
        display_element_callback.apply(this, item);
    })

        /****** color options ******/
    let same_color_elements = [
            ['#background-color','.notifal-pulse-temp1,.notifal-temp2-background,' +
            '.notifal-pulse-temp3,.notifal-temp4-content,.notifal-temp4-content ' +
            '.notifal-corner1,.notifal-temp4-content .notifal-corner2','background-color'],
            ['#color2','.notifal-pulse-temp1,.notifal-pulse-temp3,.notifal-pulse-temp2 img','border-color'],
            ['#close-icon-color','.notifal-close','color'],
            ['#text-color','p.notifal-main-text','color'],
            ['#first-additional-info-text-color','p.first-additional-info','color'],
            ['#second-additional-info-text-color','p.second-additional-info','color'],
            ['#action-btn-text-color','.action-button-parent *','color'],
            ['#action-btn-background-color','.action-button-parent','background-color'],
        ];

    function same_color_elements_callback(a,b,c) {
        $(a).change(function (){
            $(b).css(c,$(a).val());
        })
    }
    same_color_elements.forEach(function (item, index){
        same_color_elements_callback.apply($(this), item);
    })




    /***** Position options ******/
    let position = $('#position')

    position.change(function (){change_position_input($(this))});

    function change_position_input(element){
        let option_val=element.find('option:selected').val(),
            position_input = $('.position-input'),
            distances = ["bottom","top","right","left"];
        position_input.hide();

        for(let i=0; i<distances.length; i++){
            if(~option_val.indexOf(distances[i])){
                $('#distance-'+distances[i]+'-holder').show();
            }
        }
    }


    /***** Transition Options *****/
    let transition_style = $('.transition_style'),
        initial_position='100px';
    function apply_transition(element){
        let selected_transition=element.find('option:selected').val().trim(),
            speed = Number(element.closest('div').find('input').val().trim())*1000,
            preview = $('.template-preview:visible');
        eval(selected_transition + "(preview,speed)");
        preview.css({
            'bottom':'unset',
            'top':'unset',
            'left':'unset',
            'right':'unset',
            'opacity':'1'
        })
    }
    function fade_in_transition(element,speed){
        element.hide();
        element.fadeIn(speed);
    }
    function slide_in_right_transition(element,speed){
        element.css({
            'left' : '+'+initial_position,
            'opacity' : 0
        })
        element.animate({
            left: '0',
            opacity: '1',
        },speed);
    }
    function slide_in_left_transition(element,speed){
        element.css({
            'left' : '-'+initial_position,
            'opacity' : 0
        })
        element.animate({
            left: '0',
            opacity: '1',
        },speed);
    }
    function slide_in_up_transition(element,speed){
        element.css({
            'top' : '-' + initial_position,
            'opacity' : 0
        })
        element.animate({
            top: '0',
            opacity: '1',
        },speed);
    }
    function slide_in_bottom_transition(element,speed){
        element.css({
            'top' : '+' + initial_position,
            'opacity' : 0
        })
        element.animate({
            top: '0',
            opacity: '1',
        },speed);
    }


    function fade_out_transition(element,speed){
        element.fadeOut(speed,function (){
          element.show();
        });
    }
    function slide_out_right_transition(element,speed){
        element.animate({
            left: '+'+initial_position,
            opacity: 0,
        },speed,'',function (){
            element.css({
                'left' : 'unset',
                'opacity' : 1
            })
        })
    }
    function slide_out_left_transition(element,speed){
        element.animate({
            left: '-'+initial_position,
            opacity: 0,
        },speed,'',function (){
            element.css({
                'left' : 'unset',
                'opacity' : 1
            })
        })
    }
    function slide_out_up_transition(element,speed){
        element.animate({
            top: '-'+initial_position,
            opacity: 0,
        },speed,'',function (){
            element.css({
                'top' : 'unset',
                'opacity' : 1
            })
        })
    }
    function slide_out_bottom_transition(element,speed){
        element.animate({
            top: '+'+initial_position,
            opacity: 0,
        },speed,'',function (){
            element.css({
                'top' : 'unset',
                'opacity' : 1
            })
        })
    }

    transition_style.change(function (){apply_transition($(this))});


    /*** Sound activation ***/
    let sound_audio_selection = $('#sound-audio'),
        set_volume_audio = $('#set-volume-audio'),
        volume_audio_input = $('#set-volume-audio input'),
        sound_elements = $('#sound-elements'),
        sound_active =  $('#sound-active'),
        custom_audio_holder = $('#custom-audio-holder'),
        audio_scr = $('.notif-audio-src'),
        custom_audio = $('#custom-audio'),
        select_audio_btn = $('#select-audio'),
        play_audio_btn = $('#play-audio'),
        frame;

    function select_audio(element){
        let value=element.find('option:selected').val();
        custom_audio_holder.addClass('notifal-d-none').removeClass('multi-btn-row');
        if(value==='custom-audio'){
            custom_audio_holder.removeClass('notifal-d-none').addClass('multi-btn-row');
        }else{
            audio_scr.last().attr('src','');
            audio_scr.each(function (){
                if($(this).attr('src').indexOf(value)>-1){
                    $(this).get(0).volume = volume_audio_input.val()/10;
                    $(this).get(0).play();
                }
            })
        }
    }
    function add_audio_from_media(event){
        event.preventDefault();
        if (frame) {
            frame.open();
            return;
        }
        frame = wp.media({
            frame: 'select',
            title: translated_strings.audio_media_title,
            multiple: false,
            library: { type: 'audio' },
            button: {
                text: translated_strings.choose_text,
                close: true
            }
        });
        frame.on( 'select', function() {
            let attachment = frame.state().get('selection').first();
            audio_scr.last().attr('src', attachment.attributes.url );
            audio_scr.last().get(0).play();

        });
        frame.open;
    }
    function change_audio_volume(element){
        let value=element.val()/10;

        play_audio(value);

    }

    function play_audio(volume=1){
        let value=sound_audio_selection.find('option:selected').val();
        if(value!=='custom-audio') {
            audio_scr.each(function () {
                if ($(this).attr('src').indexOf(value) > -1) {
                    $(this).get(0).volume=volume;
                    $(this).get(0).play();
                }
            })
        }else{
            if(audio_scr.last().attr('src').trim()===''){
                show_error(translated_strings.please_select_audio_text)
                setTimeout(function (){
                    hide_message_box();
                },hide_message_box_time)
            }else{
                audio_scr.last().get(0).volume=volume;
                audio_scr.last().get(0).play()
            }

        }
    }

    select_audio_btn.click(function (){add_audio_from_media(event)})
    play_audio_btn.click(function (){play_audio(volume_audio_input.val()/10)});
    sound_audio_selection.change(function (){select_audio($(this))})
    sound_active.click(function (){
        sound_elements.toggle();

    })
    volume_audio_input.mouseup(function (){
        change_audio_volume($(this));
    })
    /**** Custom css ***/

    let typingTimer,
        doneTypingInterval = 1000,
        custom_css = $('#custom-css'),
        template_preview_holder =$('.template-preview'),
        preview_style= template_preview_holder.find('style').text();

    custom_css.on('keydown',function (){
        clearTimeout(typingTimer);

    })
    custom_css.on('keyup',function (){
        clearTimeout(typingTimer);
        let new_styles= $(this).val();
        typingTimer=setTimeout(function (){
            template_preview_holder.find('style').text('').text(preview_style+new_styles)
        },doneTypingInterval);
    })





    /**
     * Source section
     *
     * Select source of notifs
     *
     * @since 1.0.0
     */
    let woo_orders_active,
        fake_orders_active,
        fakeorder_source_settings,
        woocommerce_source_settings;
    if(!empty(is_woocommerce_active)){

        woo_orders_active=$('#woo-orders-active'),
        fake_orders_active=$('#fake-orders-active'),
        fakeorder_source_settings=$('#fakeorder-source-settings'),
        woocommerce_source_settings=$('#woocommerce-source-settings');

        woo_orders_active.click(function (){
            woocommerce_source_settings.slideToggle();
            if(fake_orders_active.is(':checked')){
                fakeorder_source_settings.slideToggle();
                fake_orders_active.removeAttr("checked")
            }
        })
        fake_orders_active.click(function (){
            fakeorder_source_settings.slideToggle();
            if(woo_orders_active.is(':checked')){
                woocommerce_source_settings.slideToggle();
                woo_orders_active.removeAttr("checked")
            }
        })
    }











    /**
     * Save and update notif
     */
    /*** error message link ***/
    function error_action_btn(element){
        let data_action = element.attr('data-action');
        hide_show_main_menu_content('',data_action);
        main_menu.removeClass('active');
        main_menu.each(function (){
            if($(this).attr('data-action') === data_action){
                $(this).addClass('active');
            }
        })
    }
    message_box.on('click','a.error-action-btn',function (){
        error_action_btn($(this))
    });


    /**** remove error when user want to correct ****/
    let corrected_elements = [['input','keydown']], error_class='error-blinking';
    function remove_element_error(a,b) {
        $(a).on(b,function () {
            if($(this).hasClass(error_class)){
                $(this).removeClass(error_class)
            }
        });
    }
    corrected_elements.forEach(function (item, index){
        remove_element_error.apply(this, item);
    })


    /***
     * Start saving after clicking on save button
     * ***/
    let save_btn = $('#save-notif'),
        save_loader = $('#notifal-setting-save .notifal-loader');


    save_btn.click(function (){
        /***
         * General
         */
        error_flag = false;
        hide_message_box();



        /*** Input variables ***/
        let data=[];
        let inputs= [
            ['notif_title','#notif-title'],
            ['notif_id','#notif-id'],
            ['audio_volume','#audio-volume'],
            ['custom_main_text','#custom-main-text'],
            ['first_additional_info_text','#first-additional-info-text'],
            ['second_additional_info_text','#second-additional-info-text'],
            ['action_button_text','#action-button-text'],
            ['background_color','#background-color'],
            ['color2','#color2'],
            ['close_icon_color','#close-icon-color'],
            ['text_color','#text-color'],
            ['first_additional_info_text_color','#first-additional-info-text-color'],
            ['second_additional_info_text_color','#second-additional-info-text-color'],
            ['action_btn_text_color','#action-btn-text-color'],
            ['action_btn_background_color','#action-btn-background-color'],
            ['distance_top','#distance-top'],
            ['distance_bottom','#distance-bottom'],
            ['distance_left','#distance-left'],
            ['distance_right','#distance-right'],
            ['showing_transition_speed','#showing-transition-speed'],
            ['hiding_transition_speed','#hiding-transition-speed'],
            ['display_duration','#display-duration'],
            ['initial_delay','#initial-delay'],
            ['interval_delay','#interval-delay'],
            ['notif_counter','#notif-counter'],
            ['custom_css','#custom-css'],
        ];
        if(!empty(is_woocommerce_active)){
            inputs.push(['stock_max_quantity','#stock-max-quantity']);
            inputs.push(['woo_orders_time','#woo-orders-time']);
            inputs.push(['fake_orders_time','#fake-orders-time']);
            inputs.push(['fake_orders_fn','#fake-orders-fn']);
            inputs.push(['fake_orders_ln','#fake-orders-ln']);
            inputs.push(['fake_orders_cities','#fake-orders-cities']);
            inputs.push(['fake_orders_counter','#fake-orders-counter']);
        }
        function get_input_value(a,b) {
            data[a] = $(b).val().trim();
        }
        inputs.forEach(function (item, index){
            get_input_value.apply(this, item);
        })

        /*** select options variables ***/
        let select_options = [
            ['position','#position'],
            ['show_transition_style','#show-transition-style'],
            ['hide_transition_style','#hide-transition-style'],
            ['notif_counter_type','#notif-counter-type'],
            ['page_type','#page-type'],
            ['sound_audio','#sound-audio'],
        ];
        if(!empty(is_woocommerce_active)){
            select_options.push(['notif_products','#notif-products']);
        }
        function get_selectOption_value(a,b) {
            data[a] = $(b).find('option:selected').val();
        }
        select_options.forEach(function (item, index){
            get_selectOption_value.apply(this, item);
        })
        /*** text variables ****/
        if(!empty(is_pro_active)) {
            if(!empty(is_woocommerce_active)){
                data['selected_products']=[];
                data['selected_categories']=[];
                data['selected_category_pages']=[];
            }
            data['selected_pages']=[];
            let texts = [
                ['selected_pages','.selected-page','.selected-page-id'],
            ];
            if(!empty(is_woocommerce_active)){
                texts.push(['selected_products','.selected-products','.selected-id']);
                texts.push(['selected_categories','.selected-category','.selected-id']);
                texts.push(['selected_category_pages','.selected-category-pages','.selected-page-id']);
            }
            function get_element_texts(a,b,c) {
                $(b).each(function (){
                    data[a].push($(this).find(c).text().trim());
                })

            }
            texts.forEach(function (item, index){
                get_element_texts.apply(this, item);
            })
        }


        /*** tags with src attr ***/
        let src_data = [
            ['custom_audio_src','.notif-audio-src']
        ]
        function get_element_src(a,b) {
            let src;
            if(a==='custom_audio_src'){
                src=$(b).last().attr('src');
            }
            data[a]=src.trim();
        }
        src_data.forEach(function (item, index){
            get_element_src.apply(this, item);
        })


        /*** checkbox inputs ****/
        let checkbox = [
            ['notif_active','#notif-active','single'],
            ['selected_template','input[name="template"]','mluti','radio'],
            ['display_options','#display-options input','mluti','checkbox'],
            ['sound_active','#sound-active','single'],
            ['mobile_inactive','#mobile-inactive','single'],
        ]
        if(!empty(is_woocommerce_active)){
            checkbox.push(['fake_orders_active','#fake-orders-active','single']);
            checkbox.push(['first_letter_active','#first-letter-active','single']);
            checkbox.push(['woo_orders_active','#woo-orders-active','single']);
            checkbox.push(['display_duplicate_orders','#display-duplicate-orders','single']);
        }
        function get_checkbox_val(a,b,c,d) {
            if(c==='single'){
                data[a]=$(b).is(':checked');
            }else{
                $(b).each(function (){
                    let id=$(this).attr("id").replaceAll('-','_');
                    if(d==='radio'){
                        if($(this).is(':checked'))
                        data[a]=id;
                    }else{
                        data[id]=$(this).is(':checked');
                    }

                })
            }

        }
        checkbox.forEach(function (item, index){
            get_checkbox_val.apply(this, item);
        })

        /*** categorize data ***/
        let conditions = {
            'page_type':data['page_type'],
        },
        products = {},
        settings={
            'custom_main_text':data['custom_main_text'],
            'first_additional_info_text':data['first_additional_info_text'],
            'second_additional_info_text':data['second_additional_info_text'],
            'action_button_text':data['action_button_text'],
            'stock_max_quantity':data['stock_max_quantity'],
            'background_color':data['background_color'],
            'audio_volume':data['audio_volume'],
            'color2':data['color2'],
            'close_icon_color':data['close_icon_color'],
            'text_color':data['text_color'],
            'first_additional_info_text_color':data['first_additional_info_text_color'],
            'second_additional_info_text_color':data['second_additional_info_text_color'],
            'action_btn_text_color':data['action_btn_text_color'],
            'action_btn_background_color':data['action_btn_background_color'],
            'distance_top':data['distance_top'],
            'distance_bottom':data['distance_bottom'],
            'distance_left':data['distance_left'],
            'distance_right':data['distance_right'],
            'showing_transition_speed':data['showing_transition_speed'],
            'hiding_transition_speed':data['hiding_transition_speed'],
            'display_duration':data['display_duration'],
            'initial_delay':data['initial_delay'],
            'interval_delay':data['interval_delay'],
            'notif_counter':data['notif_counter'],
            'custom_css':data['custom_css'],
            'position' : data['position'],
            'show_transition_style' : data['show_transition_style'],
            'hide_transition_style' : data['hide_transition_style'],
            'notif_counter_type' : data['notif_counter_type'],
            'sound_audio' : data['sound_audio'],
            'custom_audio_src' : data['custom_audio_src'],
            'selected_template': data['selected_template'],
            'allow_close': data['allow_close'],
            'first_additional_info': data['first_additional_info'],
            'second_additional_info': data['second_additional_info'],
            'action_button': data['action_button'],
            'if_close_notif': data['if_close_notif'],
            'sound_active': data['sound_active'],
            'mobile_inactive': data['mobile_inactive'],
        },
        notif_status='';

        /**
         * if WooCommerce is active
         */
        if(!empty(is_woocommerce_active)){
            /** Setting data ***/
            settings['woo_orders_time']=data['woo_orders_time'];
            settings['fake_orders_time']=data['fake_orders_time'];
            settings['fake_orders_fn']=data['fake_orders_fn'];
            settings['fake_orders_ln']=data['fake_orders_ln'];
            settings['fake_orders_cities']=data['fake_orders_cities'];
            settings['fake_orders_counter']=data['fake_orders_counter'];
            settings['product_image']= data['product_image'];
            settings['fake_orders_active']= data['fake_orders_active'];
            settings['first_letter_active']= data['first_letter_active'];
            settings['woo_orders_active']= data['woo_orders_active'];
            settings['display_duplicate_orders']= data['display_duplicate_orders'];

            /*** Products data ***/
            products['notif_products']= data['notif_products'];
            if(!empty(is_pro_active)){
                products['selected_products']=data['selected_products'] ;
                products['selected_categories']=data['selected_categories'];
            }

        }

        /**
         * if is pro active
         */
        if(!empty(is_pro_active)){
            conditions['selected_pages']=data['selected_pages'];
            if(!empty(is_woocommerce_active)){
                conditions['selected_category_pages']=data['selected_category_pages'];
            }
        }




        if(data['notif_active']) notif_status = 'Active'; else notif_status='Inactive';

        let necessary_options=[
            ['empty',data['notif_title'],translated_strings.title,'#notif-title'],
            ['empty',data['display_duration'],translated_strings.display_duration,'#display-duration'],
            ['empty',data['initial_delay'],translated_strings.initial_delay,'#initial-delay'],
            ['empty',data['interval_delay'],translated_strings.interval_delay,'#interval-delay'],
            ['empty',data['notif_counter'],translated_strings.notif_counter,'#notif-counter'],
            ['empty',data['custom_main_text'],translated_strings.notif_text,'#custom-main-text'],
            ['check',[data['sound_audio'],data['sound_active']],data['custom_audio_src'],'select-audio',translated_strings.empty_custom_sound_file,'#select-audio'],
            ['check',[data['first_additional_info'],data['second_additional_info']],[data['first_additional_info_text'],data['second_additional_info_text']],'additional-info-text',[translated_strings.first_additional_info,translated_strings.second_additional_info],['#first-additional-info-text','#second-additional-info-text']],
            ['check',data['action_button'],data['action_button_text'],'action-button-text',translated_strings.action_button_text,'#action-button-text'],
        ];
        if(!empty(is_woocommerce_active)){
            if(!empty(is_pro_active)){
                necessary_options.push(['check',data['notif_products'],[data['selected_products'],data['selected_categories']],'notif-products-search',translated_strings.empty_selected_products,'#notif-products-search']);
                necessary_options.push(['check',data['page_type'],[data['selected_pages'],data['selected_category_pages']],'notif-page-search',translated_strings.empty_selected_page,'#notif-page-search']);
            }
            necessary_options.push(['empty',data['stock_max_quantity'],translated_strings.stock_max_quantity,'#stock-max-quantity']);
            necessary_options.push(['check',data['woo_orders_active'],data['woo_orders_time'],'woo-orders-time',translated_strings.empty_last_order_time,'#woo-orders-time']);
            necessary_options.push(['check',data['fake_orders_active'],[data['fake_orders_time'],data['fake_orders_fn'],data['fake_orders_ln'],data['fake_orders_cities'],data['fake_orders_counter'],data['fake_orders_time_range']],'fake-orders-active',translated_strings.fake_order_data_error,['#fake-orders-time','#fake-orders-fn','#fake-orders-ln','#fake-orders-cities','#fake-orders-counter','#fake-orders-time-range']]);
        }



        let default_data=[
            [data['distance_top'],'50'],
            [data['distance_bottom'],'50'],
            [data['distance_left'],'50'],
            [data['distance_right'],'50'],
            [data['showing_transition_speed'],'0.5'],
            [data['hiding_transition_speed'],'0.5'],
        ];
        function set_default_val(a,b) {
            if(empty(a)){
                a=b;
            }
        }
        default_data.forEach(function (item, index){
            set_default_val.apply(this, item);
        })

        /**
         * Start Error Handling
         */

        let click_here_text = translated_strings.click_here_text;
        function error_handling(a,b,c,d,e,f) {
            let empty_error_text=translated_strings.empty_input_error;
            if(a==='empty'){
                if(empty(b)){
                    let section_id=$(d).closest('div.notifal-setting').attr('id'),
                    error_action_tag = '<a class="error-action-btn" data-action="'+section_id+'" href="'+d+'">' + click_here_text + '</a>';
                    show_error(c +' '+ empty_error_text + ' ' + error_action_tag)
                    $(d).addClass(error_class)
                }else{
                    $(d).removeClass(error_class)
                }
            }else if(a==='check'){
                let section_id=$('#'+d).closest('div.notifal-setting').attr('id'),
                    error_action_tag = '<a class="error-action-btn" data-action="'+section_id+'" href="#'+d+'">' + click_here_text + '</a>';
                if(d==='notif-products-search') {
                    if (!no_selected_products.includes(b) && c[0].length === 0 && c[1].length===0) {
                        show_error(e + ' ' + error_action_tag);
                        $(f).addClass(error_class)
                    }else{
                        $(f).removeClass(error_class)
                    }
                }else if(d==='notif-page-search'){
                    if(b === 'all-pages') return;
                    let if_pages_id_exist=false;
                    for (let i=0;i<c.length; i++){
                        if ( c[i].length !== 0) {
                            if_pages_id_exist = true;
                        }
                    }
                    if(if_pages_id_exist){
                        $(f).removeClass(error_class)
                    }else{
                        show_error(e + ' ' + error_action_tag);
                        $(f).addClass(error_class)
                    }
                }else if(d==='select-audio'){
                    if(!b[1]) return;
                    if (b[0] === 'custom-audio' && empty(c)) {
                        show_error(e + ' ' + error_action_tag);
                        $(f).addClass(error_class)
                    }else{
                        $(f).removeClass(error_class)
                    }
                }else if(d==='woo-orders-time'){
                    if (b  && empty(c)) {
                        show_error(e + ' ' + error_action_tag);
                        $(f).addClass(error_class)
                    }else{
                        $(f).removeClass(error_class)
                    }
                }else if(d==='fake-orders-active'){
                    if (!b) return;
                    for(let i=0; i<c.length; i++){
                        if(empty(c[i])){
                            show_error(e + ' ' + error_action_tag);
                            $(f[i]).addClass(error_class)
                        } else{
                            $(f[i]).removeClass(error_class)
                        }
                    }
                }else if(d==='additional-info-text'){
                    for (let i=0;i<c.length; i++){
                        if(!b[i]) return;
                        if ( empty(c[i])) {
                            show_error(e[i] + ' ' + empty_error_text);
                            $(f[i]).addClass(error_class)
                        } else{
                            $(f[i]).removeClass(error_class)
                        }
                    }

                }else if(d==='action-button-text'){
                    if (b && empty(c)) {
                        show_error(e + ' ' + empty_error_text);
                        $(f).addClass(error_class)
                    }else{
                        $(f).removeClass(error_class)
                    }
                }
            }

            setTimeout(function (){
                hide_message_box();
            },hide_message_box_time)
        }

        necessary_options.forEach(function (item, index){
            error_handling.apply(this, item);
        })


        /***
         * Check if tags are valid
         *
         */
        let tags_input = [
            [true,data['custom_main_text']],
            [data['first_additional_info'],data['first_additional_info_text']],
            [data['second_additional_info'],data['second_additional_info_text']],
            [data['action_button'],data['action_button_text']]
            ],
            order_tags = JSON.parse(add_notif_data.order_tags),
            action_btn_link='<a class="error-action-btn" data-action="notifal-setting-source" href="#woo-orders-active">' + click_here_text + '</a>';

        /**
         * Check if order source are disable
         */
        if(!empty(is_woocommerce_active)){
            function check_if_is_order_notif(a,b){
                for (let i=0; i<tags_input.length; i++){
                    for (let j=0; j<order_tags.length; j++){
                        if(!data['woo_orders_active'] && !data['fake_orders_active']){
                            if(a){
                                if(b.indexOf(order_tags[j])>-1){
                                    show_error(translated_strings.enable_orders_text + '<br><br>' +'Invalid tag:'+order_tags[j]+'<br><br>' + action_btn_link);
                                    break;
                                }
                            }

                        }
                    }
                }
            }
            tags_input.forEach(function (item, index){
                check_if_is_order_notif.apply(this, item);
            })
        }


        /**
         * Get type of notif based on used tags
         */
        let type=[];
        if(!empty(is_woocommerce_active)){
            let stock_tags = JSON.parse(add_notif_data.stock_tags),
                discount_tags = JSON.parse(add_notif_data.discount_tags);


            function get_notif_type_by_tags(a,b){
                let tags=[[stock_tags,'stock'],[discount_tags,'discount'],[order_tags,'order']]
                if(a){
                    for(let i=0; i<tags.length; i++){
                        for (let j=0; j<tags[i][0].length; j++) {
                            if (b.indexOf(tags[i][0][j]) > -1) {
                                type.push(tags[i][1]);
                                break;
                            }
                        }
                    }

                }
            }

            tags_input.forEach(function (item, index){
                get_notif_type_by_tags.apply(this, item);
            })

            if(!type.includes('order')){
                woocommerce_source_settings.slideUp();
                fake_orders_active.removeAttr('checked');
                fakeorder_source_settings.slideUp();
                woo_orders_active.removeAttr('checked');
                settings.fake_orders_active=false;
                settings.woo_orders_active=false;
            }
        }


        if(type.length===0){
            type.push('custom');
        }

        type=unique(type);


        /**
         * End Error Handling
         */

        let notif_data={
            'id': data['notif_id'],
            'title': data['notif_title'],
            'conditions': conditions,
            'type': type,
            'settings': settings,
            'status':notif_status,
        };
        if(!empty(is_woocommerce_active)){
            notif_data['products']=products;
        }
        if(!error_flag){
            $.ajax({
                type:'POST',
                url:save_notif.ajax_url,
                data: {action: 'save_notif','notif_data':notif_data },
                cache: false,
                beforeSend: function () {
                    save_btn.addClass('notifal-disable');
                    save_loader.show();
                },
                success: function (response) {
                    let data=JSON.parse(response),
                        message = data.message,
                        edit_url = data.edit_url;
                    if(message === 'Inserted' || message === 'Updated'){
                        show_success(translated_strings.notif_save_successfully)
                        if(!empty(edit_url)){
                            setTimeout(function (){
                                window.location.replace(edit_url);
                            },2000)
                        }

                    }else if(message==='More than one active'){
                        show_pro_popup(translated_strings.more_than_one_active_notif_text);
                    }
                    else{
                        show_error(translated_strings.faild_notif_save)
                    }
                },
                error:function () {
                    show_error(translated_strings.general_error_text)
                },
                complete:function (){
                    save_btn.removeClass('notifal-disable');
                    save_loader.hide();
                }
            })
        }


    })


    $(document).on('click', '.notif-copy-text', function () {
        let textToCopy = $(this).attr('data-copy-text').trim(),
            tempInput = $('<input>');

        $('body').append(tempInput);
        tempInput.val(textToCopy).select();

        document.execCommand('copy');

        tempInput.remove();
    });

    function empty(input){
        return input === '';
    }




})