/**
 * Notifs list js
 * @version 1.0.0
 * @type {(function(*, *): *)|jQuery}
 */
var j = jQuery.noConflict();
j(document).ready(function($) {
    /*** General ***/

    /*** check Pro ***/
    let is_pro_active=notif_list_data.is_pro_active,
        popup,popup_message,close_pro_popup,
        popup_class='.notifal-pro-feature-popup';

    if(empty(is_pro_active)){
        popup_message = $('#pro-feature-text');
        popup = $(popup_class);
        $('body').prepend(popup);
        close_pro_popup = $('.popup-close-btn');
        close_pro_popup.click(function (){popup.fadeToggle()});
        let change_notif_status_btn = $('.change-notif-status');

        change_notif_status_btn.click(function (){
            let i=0;
            change_notif_status_btn.each(function (){
                if($(this).is(':checked')){
                    i++;
                }
            })
            if($(this).is(':checked')){
                if(i!==1){
                    show_pro_popup(translated_strings.more_than_one_active_notif_text);
                    $(this).removeAttr('checked');
                }
            }
        })


        /*** Popup handler ***/
        function show_pro_popup(message){
            popup_message.text(message)
            popup.fadeToggle();
        }
    }

    /**** Tooltip js ****/
    let notifal_tooltip_btn = $('.notifal-tooltip-button'),
        notifal_close_tooltip = $('.notifal-close-tooltip'),
        notifal_tooltip = $('.notifal-tooltip');


    function show_products(element){
        let tooltip= element.closest('.notifal-tooltip-holder').find('.notifal-tooltip');
        if(!tooltip.is(":visible")){
            notifal_tooltip.hide();
            tooltip.show();
        }else{
            tooltip.hide();
        }
    }
    function hide_tooltip(element){
        element.closest('.notifal-tooltip').hide();
    }
    function hide_if_outside(event){
        var $target = $(event.target);
        if(!$target.closest('.notifal-tooltip-holder').length) {
            notifal_tooltip.hide();
        }
        if(!$target.closest('.change-notif-status').length) {
            popup.fadeOut();
        }
    }

    notifal_tooltip_btn.click(function (){show_products($(this))})
    notifal_close_tooltip.click(function (){ hide_tooltip($(this)) })
    $(document).click(function(event) { hide_if_outside(event) });


    /**** Hide and show message box ***/
    let message_box = $('#notifal-setting-message');

    function show_error(text){
        message_box.html(text).addClass('notifal-error').slideDown();
    }

    function show_success(text){
        message_box.html(text).addClass('notifal-success').slideDown();
    }

    function hide_message_box(){
        message_box.removeClass('notifal-error notifal-success').slideUp();
    }

    /**
     * Prop all checkbox
     */
    let all_checkbox = $('#check-all'),
        tbody_rows=$('#notifs-table').find('tbody tr'),
        row_checkbox =tbody_rows.find('td:first-child input');
    all_checkbox.click(function (){
        let checked=''
        if($(this).is(':checked')){
            checked = 'checked'
        }
        tbody_rows.each(function (){
            if(checked!==''){
                $(this).find('td:first-child input').prop("checked", true);
            }else{
                $(this).find('td:first-child input').prop("checked", false);
            }
        })
    })

    row_checkbox.click(function (){
        let checkall=true;
        $('#notifs-table').find('tbody tr').each(function (){
            if(!$(this).find('td:first-child input').is(':checked')){
                checkall=false;
            }
        })
        if(checkall){
            all_checkbox.prop("checked", true);
        }else{
            all_checkbox.prop("checked", false);
        }
    })


    /***
     * Search notifs by title
     */
    let search_holder = $('.notifal-table-search'),
         notif_list_url=window.location.href,input_val=$(this).val();

    search_holder.on('keyup','input',function (e){
        input_val=search_holder.find('input').val();
        if (e.key === 'Enter' || e.keyCode === 13) {
            if(input_val.length<2){
                show_error(translated_strings.enter_atleast_2letter);
                return;
            }
            window.location.replace(notif_list_url+'&search='+input_val);
        }
        setTimeout(function (){
            hide_message_box();
        },3000)
    })
    search_holder.on('click','button',function (){
        input_val=search_holder.find('input').val();
        if(input_val.length<2){
            show_error(translated_strings.enter_atleast_2letter);
            return;
        }
        setTimeout(function (){
            hide_message_box();
        },3000)
        window.location.replace(notif_list_url+'&search='+input_val);
    })


    /**
     * notifs bulk actions
     */
    let bulk_action_btn= $('#notifs-bulk-action-btn'),
        bulk_action_loader=$('#bulk-action-loader'),
        table_action = $('#table-action'),
        action,
        error;

    bulk_action_btn.click(function (){
        error = false;
        let selected_notifs=[];
        tbody_rows.each(function (){
            let checkbox_input=$(this).find('td:first-child input');
            if(checkbox_input.is(':checked')){
                let id=checkbox_input.closest('tr').find('td:nth-child(2)').text();
                selected_notifs.push(id)
            }
        })
        if(table_action.find('option:selected').val().length===0){
            show_error(translated_strings.select_the_action);
            error=true;
        }
        if(selected_notifs.length===0){
            show_error(translated_strings.select_atleast_1notif);
            error=true;
        }
        if(error) {
            setTimeout(function (){
                hide_message_box();
            },3000)
            return;
        }

        action = table_action.find('option:selected').val();

        if(action==='delete'){
            if(!confirm(translated_strings.sure_to_delete_notif_text)){
                return;
            }
        }
        $.ajax({
            type: 'POST',
            url: notif_bulk_action.ajax_url,
            data: {action: 'notif_bulk_action', 'bulk_action':action ,'selected_notifs': selected_notifs},
            cache: false,
            beforeSend: function () {
                bulk_action_loader.show();
                $(this).addClass('notifal-disable');
            },
            success: function (response) {
                switch (response){
                    case 'deleted':{
                        show_success(translated_strings.deleted_successfully_text);
                        break;
                    }
                    case 'Failed to delete':{
                        show_error(translated_strings.deleted_unsuccessfully_text);
                        break;
                    }
                    case 'activated':{
                        show_success(translated_strings.activated_successfully_text);
                        break;
                    }
                    case 'Failed to activate':{
                        show_error(translated_strings.activated_unsuccessfully_text);
                        break;
                    }
                    case 'deactivated':{
                        show_success(translated_strings.deactivated_successfully_text);
                        break;
                    }
                    case 'Faild to deactivate':{
                        show_error(translated_strings.deactivated_unsuccessfully_text);
                        break;
                    }
                }
            },
            error: function () {
                show_error(translated_strings.general_error_text)
            },
            complete:function (){
                bulk_action_loader.hide();
                $(this).removeClass('notifal-disable');
                setTimeout(function (){
                    hide_message_box();
                    window.location.reload();
                },3000)

            }
        })

    })

    /***
     * Change notif status
     */
    let change_notif_status=$('.change-notif-status');
    change_notif_status.click(function (){
        let id=$(this).closest('tr').find('td:nth-child(2)').text(),
            status=$(this).is(':checked'),
            title=$(this).closest('tr').find('td:nth-child(3)').text();
            $.ajax({
                type: 'POST',
                url: update_notif_status.ajax_url,
                data: {action: 'update_notif_status', 'id':id ,'status':status },
                cache: false,
                beforeSend: function () {
                },
                success: function (response) {
                    if(response==='updated'){
                        show_success(title + ' ' + translated_strings.notif_updated_successfully_text);
                    }else{
                        show_error(translated_strings.notif_status_update_unsuccessfully_text)

                    }
                },
                error: function () {
                    show_error(translated_strings.general_error_text)
                },
                complete:function (){
                    setTimeout(function (){
                        hide_message_box();
                    },3000)

                }
            })
    })



    function empty(input){
        return input === '';
    }

})