/**
 * Order Notif scripts
 * This will be excecute on all front pages
 *
 * @version 1.0.0
 *
 * @type {(function(*, *): *)|jQuery}
 */
var j = jQuery.noConflict();
j(document).ready(function($) {

    const two_days_in_ms = 2 * 24 * 60 * 60 * 1000;
    /***
     * Select random element
     *
     * @param array - can be like $('.class')
     * @returns {*}
     */
    function get_random_element(array) {
        var m = array.length, t, i;
        while (m) {
            i = Math.floor(Math.random() * m--);
            t = array[m];
            array[m] = array[i];
            array[i] = t;
        }
        return array;
    }
    /****
     * Show notif on front
     *
     * @since 1.0.0
     * @version 1.0.0
     */
    if(Object.keys(notifal.active_notifs_data).length>2){

        /**
         * Set delay onload
         */

        let notifs = $('.notifal-template'),
            random_notif = get_random_element(notifs).slice(0, 1),
            data_id = random_notif.attr('data-id'),
            interval_delay,display_duration,initial_delay,
            display_notif=false,
            notif_error_message,
            total_notif_shown=0,
            all_noitf_counters=0,
            notif_data=[],notif_display_counter=[];


            notif_data = JSON.parse(notifal.active_notifs_data);

            initial_delay = convert_sec_to_msec(Number(notif_data[data_id].initial_delay));

            notifs.each(function (){
                data_id = $(this).attr('data-id');
                all_noitf_counters += Number(notif_data[data_id].notif_counter);
            })

        // console.log(notif_data)

        /**
         * Remove some session on load
         */
        for (let key in sessionStorage) {
            if (key.indexOf("notifal_") > -1 || key.indexOf("notifal-") > -1) {
                sessionStorage.removeItem(key);
            }
        }



        /**
         * Set notif display counter
         *
         * @param data_id
         * @param type
         */
        function set_notif_display_counter(data_id, type) {
            let storage_key = 'notifal_' + data_id,
                now = new Date().getTime();

            if (type === 'page') {
                let session_item = Number(sessionStorage.getItem(storage_key));
                if (isNaN(session_item)) {
                    session_item = 0;
                    sessionStorage.setItem(storage_key, '1');
                }
                notif_display_counter[data_id] = session_item + 1;
                sessionStorage.setItem(storage_key, notif_display_counter[data_id].toString());
            } else {
                let local_item_data = localStorage.getItem(storage_key), local_item = 0, expiry = null;

                if (local_item_data !== null) {
                    let parsed_data = JSON.parse(local_item_data);
                    local_item = parsed_data.counter;
                    expiry = parsed_data.expiry;
                    if (now > expiry) {
                        local_item = 0;
                        expiry = now + two_days_in_ms;
                    }
                } else {
                    expiry = now + two_days_in_ms;
                }

                notif_display_counter[data_id] = local_item + 1;
                localStorage.setItem(storage_key, JSON.stringify({
                    counter: notif_display_counter[data_id],
                    expiry: expiry
                }));
            }
        }



        function get_rand_between(min, max) {
            if(min!==max)
                return Math.floor(Math.random() * (max - min + 1) + min);
            else
                return min;
        }

        function get_random_from_array (array){
            const random_index = Math.floor(Math.random() * array.length);

            return array[random_index];
        }

        let count_show_index=0;

        function get_random_property(obj, notif_id) {
            if (obj === undefined) return;

            let keys = Object.keys(obj);
            if (notif_id !== '') {
                let displayed_orders_index = [],
                    storage_key = 'notifal_orders_index_' + notif_id,
                    now = new Date().getTime(),
                    notifal_orders_index = localStorage.getItem(storage_key),
                    rand_index = keys.length * Math.random() << 0;

                if (notifal_orders_index !== null) {
                    let parsed_data = JSON.parse(notifal_orders_index);

                    if (now > parsed_data.expiry) {
                        displayed_orders_index = [];
                        parsed_data.expiry = now + two_days_in_ms;
                        localStorage.setItem(storage_key, JSON.stringify({
                            displayed_orders_index,
                            expiry: parsed_data.expiry
                        }));
                    } else {
                        displayed_orders_index = parsed_data.displayed_orders_index;
                    }
                    if (displayed_orders_index.length >= keys.length) {
                        return;
                    }
                    while (true) {
                        if (displayed_orders_index.includes(keys[rand_index])) {
                            rand_index = keys.length * Math.random() << 0;
                        } else {
                            break;
                        }
                    }
                }
                return keys[rand_index];
            } else {
                return keys[keys.length * Math.random() << 0];
            }
        }


        function convert_sec_to_msec(time){
            return time*1000;
        }


        /**
         * Copy button
         */

        $(document).on('click', '.notif-copy-text', function () {
            let textToCopy = $(this).attr('data-copy-text').trim(),
                tempInput = $('<input>'),
                initialText = $(this).text();

            $('body').append(tempInput);
            tempInput.val(textToCopy).select();

            document.execCommand('copy');

            $(this).text('Copied');

            setTimeout(function() {
                $(this).text(initialText);
            }.bind(this), 2000);

            tempInput.remove();
        });

        /**
         * Set Interval
         * @type {number}
         */

        function replace_tags(a,b,c,d,e) {
            for(let j=0; j<a.length;j++){
                let text_element = $('#'+d).find(a[j]),
                    text = text_element.html().trim();

                if(text.indexOf(b)>-1){
                    if(c===''){
                        if(j!==0){
                            text_element.hide();
                        }else{
                            notif_error_message = 'Notif main text include a tag without any data!'
                            display_notif = false;
                        }
                    }
                    if(b==='{product_stock}'){
                        if(Number(c)>0 && Number(c)<Number(e)){
                            text_element.html(text.replaceAll(b,c));
                        }
                    }else{
                        text_element.html(text.replaceAll(b,c));
                    }

                }
            }
        }

        let notif_interval = setInterval(notif_interval_callback,initial_delay );

        function notif_interval_callback(){
            random_notif = get_random_element(notifs).slice(0, 1);
            data_id = random_notif.attr('data-id');
            let ajax_data=[],
            audio = random_notif.find('audio.notifal-audio'),
            notif_id = data_id.replaceAll("notif_data_",""),
            template_id = "notifal-template-"+notif_id,
            template_element = $('#'+template_id),
            need_replace = notif_data[data_id].need_replace,
            orders_counter = notif_data[data_id].real_order_data ? Object.keys(notif_data[data_id].real_order_data).length : 0,
            total_orders_counter = notif_data[data_id].total_orders_counter ?? '',
            // order_data = notif_data[data_id].real_order_data['order_0'],
            notif_counter = notif_data[data_id].notif_counter,
            notif_counter_type = notif_data[data_id].notif_counter_type,
            showing_transition_speed = notif_data[data_id].showing_transition_speed,
            hiding_transition_speed = notif_data[data_id].hiding_transition_speed,
            mobile_inactive = notif_data[data_id].mobile_inactive,
            stock_max_quantity = notif_data[data_id].stock_max_quantity,
            show_transition_style = notif_data[data_id].show_transition_style,
            hide_transition_style = notif_data[data_id].hide_transition_style,
            display_duplicate_orders = notif_data[data_id].display_duplicate_orders,
            woo_orders_active = notif_data[data_id].woo_orders_active,
            f_orders_active = notif_data[data_id].f_orders_active,
            notif_text_elements = ['p.notifal-main-text','p.first-additional-info','p.second-additional-info','p.action-button-parent'],
            display_notif_element = {
                'first_additional_info': notif_data[data_id].first_additional_info,
                'second_additional_info': notif_data[data_id].second_additional_info,
                'action_button': notif_data[data_id].action_button,
            },
            notif_initial_text_elements = [],
            audio_volume = notif_data[data_id].audio_volume,
            need_order_data = notif_data[data_id].need_order_data,
            products_data_type = notif_data[data_id].products_data_type,
            replace_texts=[],
            product_image='';
            display_notif = true;
            interval_delay = convert_sec_to_msec(Number(notif_data[data_id].interval_delay));
            display_duration = convert_sec_to_msec(Number(notif_data[data_id].display_duration));

            let is_pro_active=notifal.is_pro_active;
            if(is_pro_active===''){
                if(Object.keys(notif_data).length>1){
                    clearInterval(notif_interval);
                    return;
                }
                let pro_tags = JSON.parse(notifal.pro_tags)
                for(let i=0; i<notif_text_elements.length; i++){
                    for(let j=0; j<pro_tags.length; j++){
                        let element=template_element.find(notif_text_elements[i]);
                        if(element.text().indexOf(pro_tags[j]) > -1){
                            clearInterval(notif_interval);
                            return;
                        }
                    }
                }

                let invalid_product_types = ["all-products-except","specific-products"];
                if(invalid_product_types.includes(products_data_type)) return;
            }

            if(total_notif_shown === all_noitf_counters){
                clearInterval(notif_interval);
                return;
            }

            if(if_close_is_active(notif_id)){
                return;
            }

            if(mobile_inactive==='true' && if_is_using_mobile()){
                return;
            }

            if (notif_counter_type === 'page') {
                if (notif_counter < Number(sessionStorage.getItem('notifal_' + data_id)) + 1) {
                    clearInterval(notif_interval);
                    notif_interval = setInterval(notif_interval_callback, 1);
                    return;
                }
            } else {
                let storage_key = 'notifal_' + data_id,
                    local_item_data = localStorage.getItem(storage_key),
                    expiry = null,
                    counter = 0;

                if (local_item_data !== null) {
                    let parsed_data = JSON.parse(local_item_data);
                    expiry = parsed_data.expiry;
                    counter = parsed_data.counter;

                    if (new Date().getTime() > expiry) {
                        counter = 0;
                    }
                }

                if (notif_counter < counter + 1) {
                    clearInterval(notif_interval);
                    total_notif_shown += 1;
                    notif_interval = setInterval(notif_interval_callback, 1);
                    return;
                }
            }




            for(let k=0; k<notif_text_elements.length; k++){
                notif_initial_text_elements.push(template_element.find(notif_text_elements[k]).html().trim())
            }
            if(need_replace){
                if(need_order_data) {
                    let order_exist = false,
                        first_name='',last_name='',order_city='',order_country='',order_state='',order_time='',product_name='', product_stock='',product_regular_price='',product_sale_price='',
                        product_link='',order_company='',product_discount_amount='',product_discount_percent='',discount_ends_in='',product_sold_quantity='';
                    if(woo_orders_active==='true') {
                        /***
                         * get order data
                         *
                         */
                        order_exist = true;
                        let displayed_orders_index = [],
                            order_index = get_random_property(notif_data[data_id].real_order_data, notif_id),
                            storage_key = 'notifal_orders_index_' + [notif_id],
                            now = new Date().getTime(),
                            notifal_orders_data = localStorage.getItem(storage_key),
                            expiry;


                        if (notifal_orders_data !== null) {
                            let parsed_data = JSON.parse(notifal_orders_data);

                            if (now > parsed_data.expiry) {
                                displayed_orders_index = [];
                                expiry = now + two_days_in_ms;
                            } else {
                                displayed_orders_index = parsed_data.displayed_orders_index; // Use existing data
                                expiry = parsed_data.expiry;
                            }
                        } else {
                            expiry = now + two_days_in_ms;
                            notifal_orders_data = {
                                displayed_orders_index: [],
                                expiry: expiry
                            };
                            localStorage.setItem(storage_key, JSON.stringify(notifal_orders_data));
                        }

                        if (order_index !== undefined) {
                            displayed_orders_index.push(order_index);
                            localStorage.setItem(storage_key, JSON.stringify({
                                displayed_orders_index,
                                expiry: expiry
                            }));
                        }
                        if (display_duplicate_orders === 'true' && order_index === undefined) {
                            localStorage.setItem(storage_key, JSON.stringify({
                                displayed_orders_index: [],
                                expiry: expiry
                            }));
                            count_show_index = 0;
                            order_exist = false;
                        }

                        else{
                            if(order_index!==undefined){
                                let order_data =notif_data[data_id].real_order_data[order_index];
                                first_name = order_data['first_name'] ? order_data['first_name'] : '{first_name}';
                                last_name = order_data['last_name'] ? order_data['last_name'] : '{last_name}';
                                order_city = order_data['order_city'] ? order_data['order_city'] : '{order_city}';
                                order_country = order_data['order_country'] ? order_data['order_country'] : '{order_country}';
                                order_state = order_data['order_state'] ? order_data['order_state'] : '{order_state}';
                                order_time = order_data['order_time'] ? order_data['order_time'] : '{order_time}';
                                order_company = order_data['order_company'] ? order_data['order_company'] : '{order_company}';
                                product_name = order_data['product_name'] ? order_data['product_name'] : '{product_name}';
                                product_stock = order_data['product_stock'] ? order_data['product_stock'] : '{product_stock}';
                                product_sold_quantity = order_data['product_sold_quantity'] ? order_data['product_sold_quantity'] : '{product_sold_quantity}';
                                product_regular_price = order_data['product_regular_price'] ? order_data['product_regular_price'] : '{product_regular_price}';
                                product_sale_price = order_data['product_sale_price'] ? order_data['product_sale_price'] : '{product_sale_price}';
                                product_link = order_data['product_link'] ? order_data['product_link'] : '{product_link}';
                                product_discount_amount = order_data['product_discount_amount'] ? order_data['product_discount_amount'] : '{product_discount_amount}';
                                product_discount_percent = order_data['product_discount_percent'] ? order_data['product_discount_percent'] : '{product_discount_percent}';
                                discount_ends_in = order_data['discount_ends_in'] ? order_data['discount_ends_in'] : '{discount_ends_in}';
                                product_image = order_data['product_image'] ? order_data['product_image'] : '';
                            }


                        }



                    }
                    if(f_orders_active ==='true'){
                        order_exist = true;
                        let fake_orders_time = notif_data[data_id].f_orders_time,
                            fake_orders_fn = notif_data[data_id].f_orders_fn,
                            fake_orders_ln = notif_data[data_id].f_orders_ln,
                            fake_orders_cities = notif_data[data_id].f_orders_cities,
                            fake_order_data = notif_data[data_id].f_order_data,
                            random_product_data_index = get_random_property(fake_order_data,'',''),
                            random_product_data=fake_order_data[random_product_data_index];
                        product_name = random_product_data['product_name'] ? random_product_data['product_name'] : '{product_name}';
                        product_stock = random_product_data['product_stock'] ? random_product_data['product_stock'] : '{product_stock}';
                        product_regular_price = random_product_data['product_regular_price'] ? random_product_data['product_regular_price'] : '{product_regular_price}';
                        product_sale_price = random_product_data['product_sale_price'] ? random_product_data['product_sale_price'] : '{product_sale_price}';
                        product_link = random_product_data['product_link'] ? random_product_data['product_link'] : '{product_link}';
                        product_discount_amount = random_product_data['product_discount_amount'] ? random_product_data['product_discount_amount'] : '{product_discount_amount}';
                        product_discount_percent = random_product_data['product_discount_percent'] ? random_product_data['product_discount_percent'] : '{product_discount_percent}';
                        discount_ends_in = random_product_data['discount_ends_in'] ? random_product_data['discount_ends_in'] : '{discount_ends_in}';
                        total_orders_counter = notif_data[data_id].f_orders_counter;
                        order_city = get_random_from_array(fake_orders_cities);
                        order_time = get_random_from_array(fake_orders_time);
                        product_image = random_product_data['product_image'] ? random_product_data['product_image'] : '';



                        /**
                         * Save in storage with fixed expiration (2 days)
                         */
                        let displayed_names = [],
                            storage_key = 'notifal_orders_names_' + [notif_id],
                            now = new Date().getTime(),
                            notifal_orders_data = localStorage.getItem(storage_key);
                        if (notifal_orders_data !== null) {
                            let parsed_data = JSON.parse(notifal_orders_data);
                            if (now > parsed_data.expiry) {
                                parsed_data.names = [];
                                parsed_data.expiry = now + two_days_in_ms;
                                localStorage.setItem(storage_key, JSON.stringify(parsed_data));
                                parsed_data = null;
                            } else {
                                displayed_names = parsed_data.names;
                            }
                        } else {
                            notifal_orders_data = null;
                        }
                        while (true) {
                            last_name = get_random_from_array(fake_orders_ln);
                            first_name = get_random_from_array(fake_orders_fn);

                            if (displayed_names.length === (fake_orders_ln.length * fake_orders_fn.length)){
                                let parsed_data = JSON.parse(notifal_orders_data);
                                parsed_data.names = [];
                                parsed_data.expiry = now + two_days_in_ms;
                                localStorage.setItem(storage_key, JSON.stringify(parsed_data));
                                return;
                            }


                            if (!displayed_names.includes(first_name + ' ' + last_name)) {
                                displayed_names.push(first_name + ' ' + last_name);
                                if (!notifal_orders_data) {
                                    localStorage.setItem(storage_key, JSON.stringify({
                                        names: displayed_names,
                                        expiry: now + two_days_in_ms
                                    }));
                                } else {
                                    let parsed_data = JSON.parse(localStorage.getItem(storage_key));
                                    if (parsed_data) {
                                        parsed_data.names = displayed_names;
                                        localStorage.setItem(storage_key, JSON.stringify(parsed_data));
                                    }
                                }
                                break;
                            }
                        }

                    }

                    if(!order_exist) {
                        display_notif = false;
                        notif_error_message = 'There is no any order!'
                    }else{
                        if(woo_orders_active ==='true'){
                            replace_texts= [
                                [notif_text_elements,'{first_name}',first_name,template_id],
                                [notif_text_elements,'{last_name}',last_name,template_id],
                                [notif_text_elements,'{order_time}',order_time,template_id],
                                [notif_text_elements,'{order_company}',order_company,template_id],
                                [notif_text_elements,'{orders_counter}',total_orders_counter,template_id],
                                [notif_text_elements,'{order_city}',order_city,template_id],
                                [notif_text_elements,'{order_country}',order_country,template_id],
                                [notif_text_elements,'{order_state}',order_state,template_id],
                                [notif_text_elements,'{product_name}',product_name,template_id],
                                [notif_text_elements,'{product_stock}',product_stock,template_id,stock_max_quantity],
                                [notif_text_elements,'{product_link}',product_link,template_id],
                                [notif_text_elements,'{product_discount_amount}',product_discount_amount,template_id],
                                [notif_text_elements,'{product_discount_percent}',product_discount_percent,template_id],
                                [notif_text_elements,'{product_sale_price}',product_sale_price,template_id],
                                [notif_text_elements,'{product_regular_price}',product_regular_price,template_id],
                                [notif_text_elements,'{discount_ends_in}',discount_ends_in,template_id],
                                [notif_text_elements,'{product_sold_quantity}',product_sold_quantity,template_id],
                            ];
                        }else if(f_orders_active === 'true'){
                            replace_texts= [
                                [notif_text_elements,'{first_name}',first_name,template_id],
                                [notif_text_elements,'{last_name}',last_name,template_id],
                                [notif_text_elements,'{order_time}',order_time,template_id],
                                [notif_text_elements,'{orders_counter}',orders_counter,template_id],
                                [notif_text_elements,'{order_city}',order_city,template_id],
                                [notif_text_elements,'{product_name}',product_name,template_id],
                                [notif_text_elements,'{product_stock}',product_stock,template_id,stock_max_quantity],
                                [notif_text_elements,'{product_link}',product_link,template_id],
                                [notif_text_elements,'{product_discount_amount}',product_discount_amount,template_id],
                                [notif_text_elements,'{product_discount_percent}',product_discount_percent,template_id],
                                [notif_text_elements,'{product_sale_price}',product_sale_price,template_id],
                                [notif_text_elements,'{product_regular_price}',product_regular_price,template_id],
                                [notif_text_elements,'{discount_ends_in}',discount_ends_in,template_id],
                            ];
                        }



                    }
                }else{
                    let product_data = notif_data[data_id].product_data;
                    if(product_data === undefined || product_data.length === 0) {
                        notif_error_message="No products found";
                        return;
                    }
                    let random_product_data_index = get_random_property(product_data,''),
                    random_product_data=product_data[random_product_data_index],
                    product_name = random_product_data['product_name'] ? random_product_data['product_name'] : '{product_name}',
                    product_stock = random_product_data['product_stock'] ? random_product_data['product_stock'] : '{product_stock}',
                    product_link = random_product_data['product_link'] ? random_product_data['product_link'] : '{product_link}',
                    product_sale_price = random_product_data['product_sale_price'] ? random_product_data['product_sale_price'] : '{product_sale_price}',
                    product_regular_price = random_product_data['product_regular_price'] ? random_product_data['product_regular_price'] : '{product_regular_price}',
                    product_discount_amount = random_product_data['product_discount_amount'] ? random_product_data['product_discount_amount'] : '{product_discount_amount}',
                    product_discount_percent = random_product_data['product_discount_percent'] ? random_product_data['product_discount_percent'] : '{product_discount_percent}',
                    discount_ends_in = random_product_data['discount_ends_in'] ? random_product_data['discount_ends_in'] : '{discount_ends_in}';


                    product_image = random_product_data['product_image'] ? random_product_data['product_image'] : '';

                    replace_texts= [
                        [notif_text_elements,'{product_name}',product_name,template_id],
                        [notif_text_elements,'{product_stock}',product_stock,template_id,stock_max_quantity],
                        [notif_text_elements,'{product_link}',product_link,template_id],
                        [notif_text_elements,'{product_discount_amount}',product_discount_amount,template_id],
                        [notif_text_elements,'{product_discount_percent}',product_discount_percent,template_id],
                        [notif_text_elements,'{product_sale_price}',product_sale_price,template_id],
                        [notif_text_elements,'{product_regular_price}',product_regular_price,template_id],
                        [notif_text_elements,'{discount_ends_in}',discount_ends_in,template_id],
                    ];


                }

            }



            /**
             * replace
             */






            replace_texts.forEach(function (item, index){
                replace_tags.apply(this, item);
            });

            /*** replace p with a tag for action button ***/
            notifs.find('p.action-button-parent').each(function() {
                var $p = $(this);
                var $a = $p.find('a'); // Find the <a> tag inside the <p>
                if ($a.length === 1 && $a.attr('href').trim() !== '') {
                    var href = $a.attr('href');
                    var $newLink = $('<a></a>')
                        .attr('href', href)
                        .html($p[0].outerHTML);
                    $p.replaceWith($newLink);
                }
            });


            template_element.find('.notifal-pulse-img').empty().html(product_image);
            let all_tags = JSON.parse(notifal.all_notif_tags)
            for(let i=0; i<notif_text_elements.length; i++){
                for(let j=0; j<all_tags.length; j++){
                    let element=template_element.find(notif_text_elements[i]);
                    if(element.text().indexOf(all_tags[j]) > -1){
                        if(i===0){

                            display_notif=false;
                            notif_error_message = 'Notif main text include a tag without any data!'
                        }else{
                            element.hide();
                        }
                    }
                }
            }

            if(!display_notif){
                for(let k=0; k<notif_text_elements.length; k++){
                    template_element.find(notif_text_elements[k]).html(notif_initial_text_elements[k])
                }
                clearInterval(notif_interval);
                notif_interval = setInterval(notif_interval_callback,1)
                return ;
            }



            if(display_notif){
                hide_transition_style = hide_transition_style.replaceAll('_','-');
                show_transition_style = show_transition_style.replaceAll('_','-');
                add_arg_to_links(random_notif,notif_id,notif_data,data_id);
                random_notif.removeClass(hide_transition_style).css('animation-duration',showing_transition_speed+'s').addClass(show_transition_style);
                trigger_notif_show(data_id,notif_counter_type,audio,audio_volume,notif_id);
                random_notif.css('display','')
                setTimeout(function (){
                    random_notif.removeClass(show_transition_style).css('animation-duration',hiding_transition_speed+'s').addClass(hide_transition_style)
                },display_duration);
                setTimeout(function (){
                    for (let i=0;i<notif_text_elements.length;i++){
                        if(i===0){
                            $(notif_text_elements[i]).find('p').show();
                            for(let k=0; k<notif_text_elements.length; k++){
                                template_element.find(notif_text_elements[k]).html(notif_initial_text_elements[k])
                            }
                        }else{
                            let property=notif_text_elements[i].replaceAll('p.','').replaceAll('-','_');
                            if(display_notif_element[property]==='true'){
                                template_element.find(notif_text_elements[i]).show();
                            }
                        }

                    }


                },display_duration+(hiding_transition_speed*1000));
            }
        }



        function trigger_notif_show(data_id,type,audio,audio_volume,notif_id){
            set_notif_display_counter(data_id,type);
            clearInterval(notif_interval);
            notif_interval = setInterval(notif_interval_callback,Number(interval_delay + display_duration))
            /**
             * play audio if is active
             */
            if(audio.length>0){
                audio.get(0).volume = audio_volume/10;
                audio.get(0).play();
            }
            total_notif_shown +=1;
            let notif_counter_type = notif_data[data_id].notif_counter_type,
                counter=get_notif_display_counter(data_id,notif_counter_type);

            $.ajax({
                type: 'POST',
                url: display_notif_actions.ajax_url,
                data: {action: 'display_notif_actions', 'notif_id':notif_id , 'page_id':notifal.page_id ,'counter':counter},
                cache: false,
                beforeSend: function () {
                },
                success: function (response) {
                    if(response==='failed'){
                        console.log(translated_strings.notif_display_error)
                    }
                },
                error: function () {
                    console.log(translated_strings.notif_display_error)
                },
                complete:function (){

                }
            })
        }
    }


    /**
     * Hide if click on close icon
     *
     */
    $('.notifal-close').click(function (){hide_notif($(this))});

    function hide_notif(element) {
            let template = element.closest('.notifal-template'),
                data_id = template.attr('data-id'),
                notif_id = data_id.replaceAll("notif_data_", ""),
                notif_data = JSON.parse(notifal.active_notifs_data),
                if_close_notif = notif_data[data_id].if_close_notif,
                notif_counter_type = notif_data[data_id].notif_counter_type,
                storage_key = 'notifal_if_close_settings',
                now = new Date().getTime(),
                close_setting = [],
                counter=get_notif_display_counter(data_id,notif_counter_type),
                notifal_data = localStorage.getItem(storage_key);
            if (if_close_notif === 'true'){
                if (notifal_data !== null) {
                    let parsed_data = JSON.parse(notifal_data);
                    if (now > parsed_data.expiry) {
                        close_setting = [];
                        parsed_data.expiry = now + two_days_in_ms;
                        localStorage.setItem(storage_key, JSON.stringify({
                            close_setting,
                            expiry: parsed_data.expiry
                        }));
                    } else {
                        close_setting = parsed_data.close_setting;
                    }
                } else {
                    notifal_data = {
                        close_setting: [],
                        expiry: now + two_days_in_ms
                    };
                    localStorage.setItem(storage_key, JSON.stringify(notifal_data));
                }

                close_setting.push(notif_id);

                localStorage.setItem(storage_key, JSON.stringify({
                    close_setting,
                    expiry: notifal_data.expiry || (now + two_days_in_ms)
                }));
            }

        hideNotif(template);
        $.ajax({
            type: 'POST',
            url: close_notif_actions.ajax_url,
            data: {action: 'close_notif_actions', 'notif_id':notif_id , 'page_id':notifal.page_id , 'counter':counter},
            cache: false,
            beforeSend: function () {
            },
            success: function (response) {
                if(response==='failed'){
                    console.log(translated_strings.notif_display_error)
                }
            },
            error: function () {
                console.log(translated_strings.notif_display_error)
            },
            complete:function (){

            }
        })
    }

    function add_arg_to_links(targetDiv,notif_id,notif_data,data_id){
        targetDiv.find('a').each(function() {
            let currentHref = $(this).attr('href'),
                notif_counter_type = notif_data[data_id].notif_counter_type,
                counter = get_notif_display_counter(data_id,notif_counter_type);
            if (currentHref) {
                const url = new URL(currentHref, window.location.origin);
                url.searchParams.set('action_notif', 'click');
                url.searchParams.set('notif_id', notif_id);
                url.searchParams.set('notif_action_position', counter+1);
                $(this).attr('href', url.toString());
            }
        });
    }



    function hideNotif(template){
        template.hide()
        if_close_is_active();
    }


    function if_close_is_active(notif_id) {
        let storage_key = 'notifal_if_close_settings',
            now = new Date().getTime();
        let notifal_data = localStorage.getItem(storage_key);
        if (notifal_data === null) return false;

        let parsed_data = JSON.parse(notifal_data);
        if (now > parsed_data.expiry) {
            localStorage.setItem(storage_key, JSON.stringify({
                close_setting: [],
                expiry: now + two_days_in_ms
            }));
            return false;
        }
        return parsed_data.close_setting.includes(notif_id);
    }




    function if_is_using_mobile(){
        if( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {
            return true;
        }
        return false;
    }

    function get_notif_display_counter(data_id, type) {
        let storage_key = 'notifal_' + data_id;
        let counter = 0;

        if (type === 'page') {
            let session_item = Number(sessionStorage.getItem(storage_key));
            if (!isNaN(session_item)) {
                counter = session_item;
            }
        } else {
            let local_item_data = localStorage.getItem(storage_key);
            if (local_item_data !== null) {
                let parsed_data = JSON.parse(local_item_data);
                counter = parsed_data.counter || 0;
            }
        }

        return counter;
    }



})
