<?php
namespace Notifal;
use Exception;

if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * Templates handler
 * @version 1.0.0
 */
class templates{

    /**
     * Backend template path
     * @var string
     * @since 1.0.0
     */
    public static string $backend_template_path = Notifal_DIR.'templates/backend/';



    /**
     * notif template path
     * @var string
     * @since 1.0.0
     */
    public static string $notif_template_path = Notifal_DIR.'templates/frontend/notif/';

    /**
     * Get backend template path
     *
     * @param string $file_path
     * @version 1.0.0
     * @return string
     * @since 1.0.0
     */
    public static function get_backend_template_path(string $file_path): string
    {
        return self::$backend_template_path . $file_path;
    }


    /**
     * render notifal content
     *
     * @param $file_path
     * @return false|string
     * @since 1.0.0
     */
    public static function get_notifal_content_notice($file_path){


        set_error_handler(function () {

        });

        try {
            $data = file_get_contents($file_path);

            if ($data === false) {
                return "Unable to fetch data from the woo-plugins.com. Please check your network.";
            } else {
                return file_get_contents($file_path);
            }
        } catch (Exception $e) {
            return "An error occurred: " . $e->getMessage();
        } finally {
            restore_error_handler();
        }
    }






}
