<?php
namespace Notifal;

if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * WordPress handler
 * @version 1.0.0
 */
class wordpress
{


    /**
     * backend assets
     *
     * @since 1.0.0
     *
     * @var string
     */
    public static string $backend_asset_path = Notifal_URL . 'assets/backend/';


    public function __construct()
    {
        add_action('admin_init',[$this,'admin_init']);
        add_action('admin_print_scripts', [$this, 'enqueue_backend_script']);
        add_action('plugins_loaded', [$this,'notifal_load_textdomain']);
    }

    /**
     * Enqueue backend scripts
     * @return void
     */
    public function enqueue_backend_script(){
        wp_enqueue_style('notifalGeneral', self::$backend_asset_path . 'general.min.css', '', Notifal_VERSION);

    }

    /**
     * load text domain
     * @return void
     */
    public function notifal_load_textdomain(){
        load_plugin_textdomain(Notifal_DOMAIN, false, Notifal_DIR . '/languages');
    }


    public function admin_init(){
        if(notif::is_notifal_pages() && !isset($_GET['license_data'])){
            remove_all_actions( 'admin_notices' );
            remove_all_actions( 'all_admin_notices' );
        }
    }

}