<?php
namespace Notifal;
if ( ! defined( 'ABSPATH' ) ) exit;


trait translatejs{

    /**
     * get translated strings as array - backend
     *
     * @since 1.0.0
     * @return array
     */
    public static function backend_notif_translations(): array
    {
        $string_sections=array(
            'empty_input_error',
            'title',
            'display_duration',
            'initial_delay',
            'interval_delay',
            'stock_max_quantity',
            'first_additional_info',
            'second_additional_info',
            'notif_counter',
            'audio_media_title',
            'choose_text',
            'copied_text',
            'general_error_text',
            'empty_selected_products',
            'empty_selected_page',
            'empty_custom_sound_file',
            'empty_last_order_time',
            'fake_order_data_error',
            'empty_stock_max_quantity',
            'notif_text',
            'order_time_text',
            'stock_text',
            'action_button_text',
            'click_here_text',
            'notif_save_successfully',
            'faild_notif_save',
            'enter_atleast_2letter',
            'select_atleast_1notif',
            'select_the_action',
            'sure_to_delete_notif_text',
            'deleted_successfully_text',
            'deleted_unsuccessfully_text',
            'activated_successfully_text',
            'activated_unsuccessfully_text',
            'deactivated_successfully_text',
            'deactivated_unsuccessfully_text',
            'notif_status_update_unsuccessfully_text',
            'notif_updated_successfully_text',
            'please_select_audio_text',
            'enable_orders_text',
            'more_than_one_active_notif_text',
            'pro_template_message',
            'pro_tags_message',
            'pro_options_message',
            );
        $translated_strings=array(
            esc_html__('can not be empty!' , Notifal_DOMAIN),
            esc_html__('Title' , Notifal_DOMAIN),
            esc_html__('Display duration' , Notifal_DOMAIN),
            esc_html__('Initial delay' , Notifal_DOMAIN),
            esc_html__('Interval delay' , Notifal_DOMAIN),
            esc_html__('Stock Maximum Quantity' , Notifal_DOMAIN),
            esc_html__('Additional Info 1' , Notifal_DOMAIN),
            esc_html__('Additional Info 2' , Notifal_DOMAIN),
            esc_html__('Notif counter' , Notifal_DOMAIN),
            esc_html__('Select/Upload notif audio' , Notifal_DOMAIN),
            esc_html__('Choose' , Notifal_DOMAIN),
            esc_html__('Copied!' , Notifal_DOMAIN),
            esc_html__('An error occurred.Try again later.' , Notifal_DOMAIN),
            esc_html__('You did not select any products.' , Notifal_DOMAIN),
            esc_html__('You did not select any pages.' , Notifal_DOMAIN),
            esc_html__('You did not select any audio.' , Notifal_DOMAIN),
            esc_html__('Please enter the number of days to display orders.' , Notifal_DOMAIN),
            esc_html__('Some fields related to fake orders are incomplete.' , Notifal_DOMAIN),
            esc_html__('Maximum stock quantity filed' , Notifal_DOMAIN),
            esc_html__('Notif text' , Notifal_DOMAIN),
            esc_html__('Order time text' , Notifal_DOMAIN),
            esc_html__('Stock text' , Notifal_DOMAIN),
            esc_html__('Action button text' , Notifal_DOMAIN),
            esc_html__('Click here' , Notifal_DOMAIN),
            esc_html__('Notif saved successfully, reloading...' , Notifal_DOMAIN),
            esc_html__('An error occurred while saving the notification.Try again' , Notifal_DOMAIN),
            esc_html__('Enter at least 2 letters' , Notifal_DOMAIN),
            esc_html__("You didn't select any notif!" , Notifal_DOMAIN),
            esc_html__("Select the action!" , Notifal_DOMAIN),
            esc_html__("Selected notifs will be permanently deleted.Are you sure?" , Notifal_DOMAIN),
            esc_html__("Selected notifs deleted successfully.reloading..." , Notifal_DOMAIN),
            esc_html__("An error occurred while deleting notifs, try again." , Notifal_DOMAIN),
            esc_html__("Selected notifs activated successfully.reloading..." , Notifal_DOMAIN),
            esc_html__("An error occurred while activating notifs, try again." , Notifal_DOMAIN),
            esc_html__("Selected notifs deactivated successfully.reloading..." , Notifal_DOMAIN),
            esc_html__("An error occurred while deactivating notifs, try again." , Notifal_DOMAIN),
            esc_html__("An error occurred while updating notif status, try again." , Notifal_DOMAIN),
            esc_html__("notif update successfully." , Notifal_DOMAIN),
            esc_html__("Select audio first then try to play." , Notifal_DOMAIN),
            esc_html__("To use order-related tags, you need to enable real or fake orders. Please activate orders or remove these tags." , Notifal_DOMAIN),
            esc_html__("You have the Lite version, you can't have more than one active notification at the same time. To save a notification, first disable notif, then save it.",Notifal_DOMAIN),
            esc_html__("You can not select pro templates.",Notifal_DOMAIN),
            esc_html__("You can not use pro tags.",Notifal_DOMAIN),
            esc_html__("You can not use pro option.",Notifal_DOMAIN),
        );
        return array_combine($string_sections,$translated_strings);
    }


    /**
     * get translated strings as array - frontend
     *
     * @since 1.0.0
     *
     * @return array
     */
    public static function frontend_notif_translations(): array
    {
        $string_sections=array(
            'notif_display_error',
            );
        $translated_strings=array(
            esc_html__("Notifal:An error occurred while saving notif data" , Notifal_DOMAIN),
        );
        return array_combine($string_sections,$translated_strings);
    }

    /**
     * enqueue translation data
     *
     * @param $handle
     * @param $object
     * @param $data
     *
     * @since 1.0.0
     *
     * @return void
     */
    public static function enqueue_translation_data($handle,$object,$data){
        wp_localize_script($handle,$object,$data);
    }


}

