<?php
if ( ! defined( 'ABSPATH' ) ) exit;
use Notifal\maintenance as maintenance;
use Notifal\notif\analytics;
use Notifal\notif;
/**
 * Template: Dashboard
 *
 * @version 1.1.0
 */
?>
<div class="notifal-dashboard-wrapper">
    <div class="notifal-dashboard-header">
        <div class="notifal-dashboard-header-title">
            <h2><?php esc_html_e('Dashboard',Notifal_DOMAIN) ?></h2>
</div>
<img src="<?php echo $functions::get_image("logo.svg") ?>">
</div>
<div class="notifal-pro-banner">
    <div class="pro-banner-details">
        <img src="<?php echo $functions::get_image("pro-banner.png") ?>">
        <h2><?php esc_html_e('Leave a Review & Unlock 30 Days of Pro!',Notifal_DOMAIN) ?></h2>
        <p><?php esc_html_e('Your feedback matters! By leaving a quick review, you’ll receive 30 days of free access to Pro features, including simultaneous notifications, full analytics, advanced settings, and more. Experience up to a 70% increase in effectiveness with Pro tools!',Notifal_DOMAIN) ?></p>
        <a href="https://woo-plugins.com/woonotif-pro-trial" target="_blank"><?php esc_html_e('Read more',Notifal_DOMAIN) ?></a>
    </div>
</div>
<div class="notifal-dashboard-body <?php if(!maintenance::is_pro_active()) echo 'pro-blur-content' ?>">
    <div class="notifal-dashboard-content">
        <b>
            <?php
            $value = get_option('Notifal_last_update_analytics');
            printf(esc_html__('Last updated: %s',Notifal_DOMAIN),$value ?: __('Not updated yet!',Notifal_DOMAIN));
            ?>
        </b>
        <div class="notifal-analytics">
            <div class="notifal-analytics-item">
                <div class="notifal-analytics-icon">
                    <img src="<?php echo $functions::get_image("users.svg") ?>">
                </div>
                <span><?php esc_html_e('Total Users',Notifal_DOMAIN) ?></span>
                <?php if(maintenance::is_pro_active()): ?>
                <p><?php echo \Notifal_Pro\notif\analytics::get_option_data('Notifal_all_notif_data','total_user',0) ?></p>
                <?php endif; ?>
            </div>
            <div class="notifal-analytics-item">
                <div class="notifal-analytics-icon">
                    <img src="<?php echo $functions::get_image("eye.svg") ?>">
                </div>
                <span><?php esc_html_e('Total Views',Notifal_DOMAIN) ?></span>
                <?php if(maintenance::is_pro_active()): ?>
                <p><?php echo \Notifal_Pro\notif\analytics::get_total_views(); ?></p>
                <?php endif; ?>
            </div>
            <div class="notifal-analytics-item">
                <div class="notifal-analytics-icon">
                    <img src="<?php echo $functions::get_image("cursor.svg") ?>">
                </div>
                <span><?php esc_html_e('Click Rate',Notifal_DOMAIN) ?></span>
                <?php if(maintenance::is_pro_active()): ?>
                    <p><span>%</span><?php echo \Notifal_Pro\notif\analytics::get_click_rate(); ?></p>
                <?php endif; ?>

            </div>
            <div class="notifal-analytics-item">
                <div class="notifal-analytics-icon">
                    <img src="<?php echo $functions::get_image("circle-xmark.svg") ?>">
                </div>
                <span><?php esc_html_e('Close Rate',Notifal_DOMAIN) ?></span>
                <?php if(maintenance::is_pro_active()): ?>
                    <p><span>%</span><?php echo \Notifal_Pro\notif\analytics::get_close_rate(); ?></p>
                <?php endif; ?>
            </div>
        </div>
<!--        <div class="notifal-analytics-review">-->
<!--            <div class="notifal-analytics-review-text">-->
<!--                <h2><img src="--><?php //echo $functions::get_image("rocket.png") ?><!--">--><?php //esc_html_e('Get Free Analytics Review!',Notifal_DOMAIN) ?><!--</h2>-->
<!--                <p>--><?php //esc_html_e('Want to make sure your notifications are performing at their best? Just enter your email address. Our team will review it for free and, if there’s room for improvement, we’ll reach out with personalized tips to boost your results! We’re here to help you succeed.',Notifal_DOMAIN) ?><!--</p>-->
<!--            </div>-->
<!--            <div class="notifal-analytics-review-form">-->
<!--                <input type="email" placeholder="Email address">-->
<!--                <input type="submit" value="Share analytics">-->
<!--                <a>--><?php //esc_html_e('How it works?',Notifal_DOMAIN) ?><!--</a>-->
<!--            </div>-->
<!--        </div>-->
        <div class="notifal-analytics-table">
            <table id="notifs-table">
                <thead>
                <tr>
                    <th><?php esc_html_e('ID',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Title',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Views',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Close rate',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Click rate',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Total users',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Sold products',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Total orders',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Total revenue',Notifal_DOMAIN) ?></th>
                </tr>
                </thead>
                <tbody>
                <?php
                if(maintenance::is_pro_active()):
                    $notifs = \Notifal_Pro\notif\analytics::get_notification_stats();
                    foreach ($notifs as $notif):
                    $notif_id = $notif['notif_id'];
                    $notif_data = notif::get_notif_by_id($notif_id);
                    $edit_url = notif::notif_edit_url($notif_id);
                    ?>
                    <tr>
                        <td>
                            <a target="_blank" href="<?php echo $edit_url ?>">
                                <?php echo $notif['notif_id']; ?>
                            </a>
                        </td>
                        <td>
                            <?php echo $notif_data->title; ?>
                        </td>
                        <td>
                            <?php echo $notif['views']; ?>
                        </td>
                        <td>
                            <?php echo round($notif['close_rate'],1); ?>
                        </td>
                        <td>
                            <?php echo round($notif['click_rate'],1); ?>
                        </td>
                        <td>
                            <?php echo $notif['total_users']; ?>
                        </td>
                        <td>
                            <?php echo $notif['sold_products']; ?>
                        </td>
                        <td>
                            <?php echo $notif['total_orders']; ?>
                        </td>
                        <td>
                            <?php echo $notif['total_revenue']; ?>
                        </td>
                    </tr>
                    <?php
                    endforeach;
                    endif;
                    ?>
                </tbody>
            </table>
        </div>
    </div>

    <div class="notifal-dashboard-sidebar">
        <div class="notifal-analytics-revenue">
            <div class="notifal-total-revenue">
                <div class="notifal-analytics-icon">
                    <img src="<?php echo $functions::get_image("dollar.svg") ?>">
                </div>
                <div>
                    <span><?php esc_html_e('Total Revenue',Notifal_DOMAIN) ?></span>
                    <p>
                        <?php
                        $data = analytics::get_total_revenue_data();
                        echo $data['total_revenue'];
                        ?>
                    </p>
                </div>
            </div>
            <div class="notifal-revenue-details">
                <span><?php esc_html_e('Products Sold via Notifal',Notifal_DOMAIN) ?></span>
                <p>
                    <?php
                    echo $data['total_sold_products'];
                    ?>
                </p>

            </div>
            <div class="notifal-revenue-details">
                <span><?php esc_html_e('Orders Influenced by Notifal',Notifal_DOMAIN) ?></span>
                <p>
                    <?php
                    echo $data['total_orders'];
                    ?>
                </p>
            </div>
        </div>
    </div>
</div>
</div>
