<?php
if ( ! defined( 'ABSPATH' ) ) exit;
use Notifal\notif as notif;
use Notifal\maintenance as maintenance;
use Notifal\templates as templates;
use Notifal\renderHtml as renderHtml;
/**
 * Template: notifications list
 *
 * @version 1.0.0
 */
?>
<?php
echo templates::get_notifal_content_notice('https://woo-plugins.com/products/Notifal/backend-general-notice.html');

?>

<div class="notifal-setting-wrapper">
    <div class="notifal-setting-header">
        <div class="notifal-setting-header-title">
            <h2><?php esc_html_e('Notifs',Notifal_DOMAIN) ?></h2>
            <a href="<?php menu_page_url('notif') ?>"><span class="dashicons dashicons-insert"></span><?php esc_html_e('Add notif',Notifal_DOMAIN) ?></a>
        </div>
        <img src="<?php echo $functions::get_image("logo.svg") ?>">
    </div>
    <div class="notifal-setting-body">
        <?php
        $status = 'All';
        if(isset($_GET['status'])){
            $status = $_GET['status'];
        }
        ?>
        <div class="notifal-table-filter">
            <a class="<?php renderHtml::add_class($status,'All','table-filter-active'); ?>" href="<?php echo notif::notifs_list_filter_link()?>"><?php esc_html_e('All',Notifal_DOMAIN) ?><span>(<?php echo sizeof(notif::get_notifs_by_status('')) ?>)</span></a>
            <a class="<?php renderHtml::add_class($status,'Active','table-filter-active'); ?>" href="<?php echo notif::notifs_list_filter_link(['status'=>'Active'])?>"><?php esc_html_e('Active',Notifal_DOMAIN) ?><span>(<?php echo sizeof(notif::get_notifs_by_status('Active')) ?>)</span></a>
            <a class="<?php renderHtml::add_class($status,'Inactive','table-filter-active'); ?>" href="<?php echo notif::notifs_list_filter_link(['status'=>'Inactive'])?>"><?php esc_html_e('Inactive',Notifal_DOMAIN) ?><span>(<?php echo sizeof(notif::get_notifs_by_status('Inactive')) ?>)</span></a>
        </div>
        <div class="notifal-table-header">
            <div class="notifal-table-action notifal-d-flex">
                <select id="table-action">
                    <option value="" hidden selected><?php esc_html_e('Bulk Actions',Notifal_DOMAIN) ?></option>
                    <option value="activate"><?php esc_html_e('Activate',Notifal_DOMAIN) ?></option>
                    <option value="deactivate"><?php esc_html_e('Deactivate',Notifal_DOMAIN) ?></option>
                    <option value="delete"><?php esc_html_e('Delete',Notifal_DOMAIN) ?></option>
                </select>
                <div class="notifal-d-flex">
                    <button id="notifs-bulk-action-btn"><?php esc_html_e('Apply',Notifal_DOMAIN) ?></button>
                    <div id="bulk-action-loader" class="notifal-loader notifal-d-none"></div>

                </div>
            </div>
            <div class="notifal-table-search">
                <?php
                $search='';
                if(isset($_GET['search'])){
                    $search=$_GET['search'];
                }
                ?>
                <input type="search" id="search-notif" value="<?php renderHtml::input_value($search,''); ?>" placeholder="<?php esc_html_e('Search part of title and press enter...',Notifal_DOMAIN) ?>">
                <button><span class="dashicons dashicons-search"></span></button>
            </div>
        </div>
        <div class="notifal-setting-table">
            <table id="notifs-table">
                <thead>
                <tr>
                    <th><input id="check-all" type="checkbox"></th>
                    <th><?php esc_html_e('ID',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Title',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Status',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Date',Notifal_DOMAIN) ?></th>
                    <?php if(maintenance::is_woocommerce_active()): ?>
                    <th><?php esc_html_e('Products',Notifal_DOMAIN) ?></th>
                    <?php endif; ?>
                    <th><?php esc_html_e('Conditions',Notifal_DOMAIN) ?></th>
                    <th><?php esc_html_e('Settings',Notifal_DOMAIN) ?></th>
                </tr>
                </thead>
                <tbody>
                <?php
                $notifs=notif::$notifs_list;
                if(!empty($notifs)):
                foreach ($notifs as $notif):
                ?>
                <tr>
                    <td><input type="checkbox"></td>
                    <td><a href="<?php echo notif::notif_edit_url($notif->id) ?>"><?php echo $notif->id ?></a></td>
                    <td><?php echo stripslashes($notif->title) ?></td>
                    <td>
                        <input class="notifal-d-none change-notif-status" type="checkbox" id="<?php echo 'notif'.$notif->id.'status' ?>" <?php renderHtml::toggle_checkbox($notif->status,'Active'); ?>>
                        <label class="notif-switch-input-label" for="<?php echo 'notif'.$notif->id.'status' ?>">Toggle</label>
                    </td>
                    <td><?php echo date('F j, Y', strtotime($notif->created_date)) ?></td>
                    <?php if(maintenance::is_woocommerce_active()): ?>
                    <td><?php renderHtml::show_prod_cat_conditions(notif::get_notif_products('type',$notif->id),notif::get_notif_products('selected_products',$notif->id),notif::get_notif_products('selected_categories',$notif->id));?></td>
                    <?php endif; ?>
                    <td><?php renderHtml::show_page_conditions(notif::get_notif_conditions('type',$notif->id),notif::get_notif_conditions('selected_pages',$notif->id),notif::get_notif_conditions('selected_category_pages',$notif->id));?></td>
                    <td><a class="notif-table-button" href="<?php echo notif::notif_edit_url($notif->id) ?>"><?php esc_html_e('Edit settings',Notifal_DOMAIN) ?></a></td>
                </tr>
                <?php endforeach;
                else:
                ?>
                <tr>
                    <td colspan="10">
                        <?php esc_html_e('No Notif Found!',Notifal_DOMAIN) ?>
                    </td>

                </tr>
                <?php endif; ?>

                </tbody>
            </table>
        </div>
        <?php
        $current=1;
        if(isset($_GET['pageNum'])){
            $current = $_GET['pageNum'];
        }
        $page_links = paginate_links( array(
            'base' => add_query_arg( 'pageNum', '%#%' ),
            'format' => '',
            'prev_text' => '<span class="dashicons dashicons-arrow-left-alt"></span>',
            'next_text' => '<span class="dashicons dashicons-arrow-right-alt"></span>',
            'total' => ceil((int)notif::$total_notifs_list_counter/10),
            'current' =>$current
        ) );

        if ( $page_links ) {
            echo '<div class="notifs-nav-holder"><div class="notif-nav-pages">' . $page_links . '</div></div>';
        }
        ?>
        <div id="notifal-setting-message" class="notifal-d-none">
        </div>
    </div>
</div>