<?php
if ( ! defined( 'ABSPATH' ) ) exit;
use Notifal\notif as notif;
use Notifal\maintenance as maintenance;
use Notifal\notif\settings as settings;
use Notifal\templates as templates;
use Notifal\renderHtml as renderHtml;
/**
 * Template: Add new notification
 *
 * @version 1.0.0
 */
?>
<?php
echo templates::get_notifal_content_notice('https://woo-plugins.com/products/Notifal/backend-general-notice.html');
?>
<div class="notifal-setting-wrapper">
    <div class="notifal-setting-header">
        <div class="notifal-setting-header-title">
            <?php if(!isset($_GET['notif_id'])): ?>
            <h2><?php esc_html_e('Add New Notif',Notifal_DOMAIN) ?></h2>
            <?php else: ?>
            <h2><?php echo esc_html__('Edit Notif',Notifal_DOMAIN) .' '. notif::get_notif_id() . ' : ' . notif::get_notif_title() ?></h2>
            <?php endif; ?>
        </div>
        <img src="<?php echo $functions->get_image("logo.svg") ?>">
    </div>
    <div class="notifal-setting-body">
        <div class="notifal-setting-menu">
            <div class="setting-menu-wrapper">
                <?php $notifs_menu=settings::notif_setting_main_menu(); $i=0;
                foreach ($notifs_menu as $menu):
                ?>
                <a data-action="<?php echo $menu['data-action'] ?>" class="<?php if($i==0) echo 'active' ?>"><?php echo $menu['name']; ?></a>
                <?php $i++; endforeach; ?>
            </div>
        </div>
        <div class="notifal-setting-options">
            <div id="notifal-setting-generals" class="notifal-setting">
                <div class="notif-setting-option-wrapper">
                    <div class="notif-option-input-wrapper">
                        <div class="input-holder">
                            <label class="notifal-title-label" for="notif-active"><?php esc_html_e('Notif Status',Notifal_DOMAIN) ?></label>

                            <div class="tooltip-label-holder">
                                <input class="notifal-d-none" type="checkbox" id="notif-active" <?php renderHtml::toggle_checkbox(notif::get_notif_status(),'Active'); ?>><label class="notif-switch-input-label" for="notif-active">Toggle</label>
                                <?php
                                $text = esc_html__('Turn this option on to display the Notif on your site. When off, the Notif will be hidden from visitors.',Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>
                        </div>

                    </div>
                </div>
                <div class="notif-setting-option-wrapper">
                    <div class="tooltip-label-holder">
                        <label class="notifal-title-label" for="notif-title"><?php esc_html_e('Notif Title',Notifal_DOMAIN) ?></label>
                        <?php
                        $text = esc_html__('Enter a title to help you organize and identify the Notif in the admin panel. This title will not be visible to visitors.',Notifal_DOMAIN);
                        renderHtml::icon_tooltip($text);
                        ?>
                    </div>
                    <input id="notif-title" value="<?php renderHtml::input_value(notif::get_notif_title(),sprintf(esc_html__('Notif %s',Notifal_DOMAIN),notif::$new_notif_id))?>" placeholder="<?php esc_html_e('Choose a name for the notif',Notifal_DOMAIN) ?>">
                    <input id="notif-id" type="hidden" value="<?php if(isset($_GET['notif_id'])) echo $_GET['notif_id']; ?>">

                </div>
                <?php if(maintenance::is_woocommerce_active()): ?>
                <div class="notif-setting-option-wrapper">
                    <div class="tooltip-label-holder">
                        <label class="notifal-title-label" for="notif-products"><?php esc_html_e('Target Products',Notifal_DOMAIN) ?></label>
                        <?php
                        $text = __('Choose which products this Notif applies to:
                                All Products: Displays for all products on your site.
                                All Except Selected: Displays for all products except those you choose.
                                Selected Products Only: Displays only for the products you select.
                                No Product:The Notif isn’t tied to any product, suitable for general updates like discount codes.',Notifal_DOMAIN);
                        renderHtml::icon_tooltip($text);
                        ?>
                    </div>
                    <select id="notif-products">
                        <?php
                        $products_conditions = settings::notif_products_condition();
                        foreach ($products_conditions as $conditions):
                            $is_pro=!empty($conditions['Pro']) && !maintenance::is_pro_active();

                            ?>
                        <option <?php if($is_pro) echo 'disabled'  ?> class="<?php if($is_pro) echo 'notifal-pro-text'  ?>" <?php renderHtml::select_option_value(notif::get_notif_products(),$conditions['value']) ?> value="<?php echo $conditions['value'] ?>" ><?php echo $conditions['name']; if($is_pro) echo '(Pro version)' ?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <?php endif; ?>
                <?php do_action('after_product_conditions') ?>
            </div>
            <div id="notifal-setting-visuals" class="notifal-setting notifal-d-none">
                <div class="notif-setting-option-wrapper">
                    <label class="notifal-title-label" for="notif-title"><?php esc_html_e('Notif Template',Notifal_DOMAIN) ?></label>
                    <p><?php esc_html_e('Select a Notif template. Each template offers unique design options and can be customized with colors and other settings.',Notifal_DOMAIN) ?><b><?php esc_html_e('The dimensions of the preview displayed here may differ from what you see on the frontend due to the replacement of tags during rendering.',Notifal_DOMAIN); ?></b></p>
                    <div class="notif-setting-templates-wrapper">
                        <?php
                        $notif_templates=settings::get_notif_templates();
                        $i=0;
                        foreach ($notif_templates as $template):
                            $is_pro=!empty($template['pro']) && !maintenance::is_pro_active();
                        ?>
                        <div class="notif-setting-template-item <?php if($is_pro) echo 'notifal-pro-feature' ?>">
                            <input type="radio" <?php if($is_pro) echo 'disabled'; ?> <?php renderHtml::toggle_checkbox($template['id'],notif::get_notif_settings('selected_template'),'checked' , [$i=>0]); ?> id="<?php echo $template['id'] ?>" name="template"  >
                            <label for="<?php echo $template['id'] ?>" class="templates">
                                <img src="<?php echo $functions->get_image($template['file_name']) ?>">
                            </label>
                        </div>
                        <?php $i++; endforeach; ?>
                    </div>
                    <div class="notif-setting-template-preview">
                        <?php
                        notif::add_template_preview();
                        ?>
                    </div>
                    <div class="setting-text-content">
                        <div class="notif-setting-option-wrapper">
                            <div class="setting-row">
                                <div class="sub-setting-column">
                                    <label class="notifal-mini-title-label" for="custom-main-text"><?php esc_html_e('Main Text',Notifal_DOMAIN) ?></label>
                                    <textarea id="custom-main-text" class="mini-textarea notif-custom-text"><?php
                                        if(maintenance::is_woocommerce_active()){
                                            $default_main_text =sprintf(__('<b>%1s</b> <b>%2s</b> from <b>%3s</b> ordered <b>%4s</b>',Notifal_DOMAIN),'{first_name}','{last_name}','{order_city}','{product_name}');
                                        }else{
                                            $default_main_text = esc_html__('Join our growing community and stay updated with the latest news!',Notifal_DOMAIN);
                                        }
                                        renderHtml::render_backend_notif_text('custom_main_text',$default_main_text,true);
                                        ?></textarea>
                                </div>
                                <div class="sub-setting-column <?php renderHtml::toggle_display(notif::get_notif_settings('first_additional_info'),'true','equal',true,[0=>1]); ?>" id="first-additional-info-text-holder">
                                    <label class="notifal-mini-title-label" for="first-additional-info-text"><?php esc_html_e('Additional Info 1',Notifal_DOMAIN) ?></label>
                                    <textarea id="first-additional-info-text"  class="mini-textarea notif-custom-text"> <?php
                                        if(maintenance::is_woocommerce_active()){
                                            $default_time_text =sprintf(__('%s ago',Notifal_DOMAIN),'{order_time}');
                                        }else{
                                            $default_time_text = esc_html__('+5,000 joined!',Notifal_DOMAIN);
                                        }
                                        renderHtml::render_backend_notif_text('first_additional_info_text',$default_time_text,true);
                                        ?></textarea>
                                </div>
                                <div class="sub-setting-column <?php renderHtml::toggle_display(notif::get_notif_settings('second_additional_info'),'true','equal',true,[0=>1]); ?>" id="second-additional-info-text-holder">
                                    <label class="notifal-mini-title-label" for="second-additional-info-text"><?php esc_html_e('Additional Info 2',Notifal_DOMAIN) ?></label>
                                    <textarea id="second-additional-info-text" class="mini-textarea notif-custom-text"><?php
                                        if(maintenance::is_woocommerce_active()){
                                            $default_stock_text =sprintf(__('only <b>%s</b> in stock',Notifal_DOMAIN),'{product_stock}');
                                        }else{
                                            $default_stock_text = esc_html__('Exclusive content',Notifal_DOMAIN);
                                        }
                                        renderHtml::render_backend_notif_text('second_additional_info_text',$default_stock_text,true);
                                        ?></textarea>
                                </div>
                                <div class="sub-setting-column <?php renderHtml::toggle_display(notif::get_notif_settings('action_button'),'true','equal',true,[0=>1]); ?>" id="actionButton-text-holder">
                                    <label class="notifal-mini-title-label" for="action-button-text"><?php esc_html_e('Action Button Text',Notifal_DOMAIN) ?></label>
                                    <textarea id="action-button-text" class="mini-textarea notif-custom-text"><?php
                                        if(maintenance::is_woocommerce_active()){
                                            $default_action_btn_text =sprintf(__('%1s Buy Now %2s',Notifal_DOMAIN),'<a class="action-button" href="{product_link}">','</a>');
                                        }else{
                                            $link = home_url();
                                            $default_action_btn_text = sprintf(esc_html__('%1s Join Now! %2s',Notifal_DOMAIN),'<a class="action-button" href="'.$link.'">','</a>');
                                        }
                                        renderHtml::render_backend_notif_text('action_button_text',$default_action_btn_text,true);
                                        ?></textarea>
                                </div>

                            </div>
                            <?php if(maintenance::is_woocommerce_active()): ?>
                            <p><?php esc_html_e('Use these tags to customize your text. HTML tags are allowed. Click on a tag to copy.',Notifal_DOMAIN) ?></p>
                            <div id="notifal-tags" class="tooltips-wrapper">
                                <?php $tags=settings::get_notif_tags();
                                foreach ($tags as $tag):
                                    $is_pro=!empty($tag['Pro']) && !maintenance::is_pro_active();
                                ?>
                                <div class="tooltip-container" data-description="<?php echo $tag['description'] ?>">
                                    <span class="pointer notif-text-tags tooltip-text <?php if($is_pro) echo 'notifal-pro-text' ?>" ><?php echo $tag['text'] ?></span>
                                </div>
                                <?php endforeach; ?>
                            </div>
                            <?php endif; ?>

                        </div>

                    </div>
                    <div class="setting-customization-wrapper">
                        <div class="setting-customization-title">
                            <h2><?php esc_html_e('Template Customization',Notifal_DOMAIN) ?></h2>
                            <p><?php esc_html_e('Personalize the selected template with your choice of colors and styles.',Notifal_DOMAIN) ?></p>
                        </div>
                        <div class="notif-setting-option-wrapper">
                            <label class="notifal-title-label"><?php esc_html_e('Display Options',Notifal_DOMAIN) ?></label>
                            <div class="notif-option-input-wrapper" id="display-options">
                               <?php
                               $display_options = settings::get_display_options();
                               $i=1;
                               foreach ($display_options as $option):
                               ?>
                               <div id="<?php echo $option['parent_id'] ?>" class="<?php if($i==sizeof($display_options)) renderHtml::toggle_display(notif::get_notif_settings('allow_close'),'true','equal',true,[0=>1]); ?>">
                                   <div class="input-holder"  >
                                       <label for="<?php echo $option['id'] ?>"><?php echo $option['label'] ?></label>
                                       <input type="checkbox" <?php renderHtml::toggle_checkbox(notif::get_notif_settings(str_replace('-','_',$option['id'])),'true',$option['checked']); ?> id="<?php echo $option['id'] ?>" >
                                       <label class="notif-switch-input-label" for="<?php echo $option['id'] ?>">Toggle</label>
                                   </div>
                               </div>

                                <?php $i++; endforeach; ?>
                            </div>

                            <div id="stock-max-quantity-holder">
                                <div class="tooltip-label-holder">
                                    <label for="stock-max-quantity"><?php esc_html_e('Show sentences containing the tag {product_stock} if the stock is less than:',Notifal_DOMAIN) ?>
                                    </label>
                                    <input id="stock-max-quantity" min="2" type="number" value="<?php renderHtml::input_value(notif::get_notif_settings('stock_max_quantity'),'10'); ?>">

                                    <?php
                                    $text = esc_html__('Display the Notif only if the product stock is lower than the entered value. If you use the {product-stock} tag in Additional Info 1 or Additional Info 2, and the stock is higher than the specified value, only the additional info will be hidden. However, if the {product-stock} tag is used in the main text, this product will not be displayed in the Notif.',Notifal_DOMAIN);
                                    renderHtml::icon_tooltip($text);
                                    ?>
                                </div>
                            </div>



                        </div>
                        <div class="notif-setting-option-wrapper">
                            <label class="notifal-title-label"><?php esc_html_e('Color Options',Notifal_DOMAIN) ?></label>
                            <div class="notif-option-input-wrapper">
                                <?php
                                $color_options =settings::get_color_options();
                                foreach ($color_options as $option):
                                ?>
                                <div class="input-holder notif-option-color-input">
                                    <?php $new_option_id=str_replace('-','_',$option['id']); ?>
                                    <label for="<?php echo $option['id'] ?>"><?php echo $option['label'] ?></label>
                                    <input type="color" id="<?php echo $option['id'] ?>" value="<?php renderHtml::input_value(notif::get_notif_settings($new_option_id),settings::get_color_defaults_by_template('template1')[$new_option_id]); ?>">
                                </div>
                                <?php endforeach; ?>
                            </div>
                        </div>
                        <div class="notif-setting-option-wrapper">
                            <div class="tooltip-label-holder">
                                <label class="notifal-title-label" for="position"><?php esc_html_e('Notif Position',Notifal_DOMAIN) ?></label>
                                <?php
                                $text = esc_html__('Select where on the screen the Notif will appear. You can also set the distance from the chosen edge for precise placement.',Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>

                            <select id="position">
                                <?php
                                $notif_position = settings::get_notif_positions();
                                foreach ($notif_position as $position):
                                ?>
                                <option <?php renderHtml::select_option_value(notif::get_notif_settings('position'),$position['value']); ?> value="<?php echo $position['value'] ?>"><?php echo $position['label'] ?></option>
                                <?php endforeach; ?>
                            </select>
                            <div class="notif-option-mini-input">
                                <?php
                                $position_distance = settings::get_notif_position_distance();
                                $i=0;
                                $condition = [
                                    "" =>"",
                                    "top-center"=>['distance-top'],
                                    "top-left"=>['distance-top','distance-left'],
                                    "top-right"=>['distance-top','distance-right'],
                                    "bottom-center"=>['distance-bottom'],
                                    "bottom-left"=>['distance-bottom','distance-left'],
                                    "bottom-right"=>['distance-bottom','distance-right'],
                                ];
                                foreach ($position_distance as $distance):
                                ?>

                                <div id="<?php echo $distance['id'].'-holder' ?>" class="position-input <?php renderHtml::toggle_display($distance['id'],$condition[notif::get_notif_settings('position')],'in_array',true,[$i=>[0,3]]); ?>">
                                    <label><?php echo $distance['label'] ?><input id="<?php echo $distance['id'] ?>" type="number" min="0" value="<?php renderHtml::input_value(notif::get_notif_settings(str_replace('-','_',$distance['id'])),'50'); ?>"></label>
                                </div>
                                <?php $i++; endforeach; ?>
                            </div>
                        </div>
                        <div class="notif-setting-option-wrapper">
                            <div class="tooltip-label-holder">
                                <label class="notifal-title-label" for="transition-style"><?php esc_html_e('Animation & Display Timing',Notifal_DOMAIN) ?></label>
                                <?php
                                $text = esc_html__('Set up animation styles and display timing to control how Notifs appear, stay, and disappear for a smooth user experience.',Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>
                            <label>
                                <?php esc_html_e('Appearing Animation',Notifal_DOMAIN) ?>
                            </label>
                            <div class="setting-row">
                                <select id="show-transition-style" class="transition_style">
                                    <?php
                                    $transition_types = settings::get_fadein_transition_types();
                                    foreach ($transition_types as $type):
                                    ?>
                                    <option <?php renderHtml::select_option_value(notif::get_notif_settings('show_transition_style'),$type["value"]); ?> value="<?php echo $type["value"] ?>"><?php echo $type['text']?></option>
                                    <?php endforeach; ?>

                                </select>
                                <label><?php esc_html_e('Animation Speed(seconds)',Notifal_DOMAIN) ?><input id="showing-transition-speed" type="number" value="<?php renderHtml::input_value(notif::get_notif_settings('showing_transition_speed'),'0.5'); ?>"></label>
                            </div>

                            <label>
                                <?php esc_html_e('Disappearing Animation',Notifal_DOMAIN) ?>
                            </label>
                            <div class="setting-row">
                                <select id="hide-transition-style" class="transition_style">
                                    <?php
                                    $transition_types = settings::get_fadeout_transition_types();
                                    foreach ($transition_types as $type):
                                        ?>
                                        <option <?php renderHtml::select_option_value(notif::get_notif_settings('hide_transition_style'),$type["value"]); ?>  value="<?php echo $type["value"] ?>"><?php echo $type['text']?></option>
                                    <?php endforeach; ?>
                                </select>
                                <label><?php esc_html_e('Animation Speed(seconds)',Notifal_DOMAIN) ?><input id="hiding-transition-speed" type="number" value="<?php renderHtml::input_value(notif::get_notif_settings('hiding_transition_speed'),'0.5'); ?>"></label>

                            </div>
                            <div class="notif-option-mini-input">
                                <?php
                                $delay_options = settings::get_delay_options();
                                foreach ($delay_options as $option):
                                ?>
                                <div class="tooltip-label-holder">
                                    <label><?php echo $option['label'] ?></label>
                                    <input min="1" id="<?php echo $option['id'] ?>" type="number" value="<?php renderHtml::input_value(notif::get_notif_settings(str_replace('-','_', $option['id'])),$option['value']); ?>">

                                    <?php
                                    $text = $option['tooltip'];
                                    renderHtml::icon_tooltip($text);
                                    ?>
                                </div>

                                <?php endforeach; ?>
                            </div>
                        </div>
                        <div class="notif-setting-option-wrapper">
                            <div class="notif-option-input-wrapper">
                                <div class="tooltip-label-holder">
                                    <div class="notif-option-sound-active input-holder">
                                        <label class="notifal-title-label" for="mobile-inactive"><?php esc_html_e('Hide Notif on Mobile',Notifal_DOMAIN) ?></label>
                                        <input <?php renderHtml::toggle_checkbox(notif::get_notif_settings('mobile_inactive'),'true',''); ?> class="notifal-d-none" type="checkbox" id="mobile-inactive"><label class="notif-switch-input-label" for="mobile-inactive">Toggle</label>
                                    </div>
                                    <?php
                                    $text = esc_html__('Enable this option to hide Notifs on mobile devices, displaying them only on desktop screens.',Notifal_DOMAIN);
                                    renderHtml::icon_tooltip($text);
                                    ?>
                                </div>
                            </div>
                        </div>
                        <div class="notif-setting-option-wrapper">
                            <div class="notif-option-input-wrapper">
                                <div class="tooltip-label-holder">
                                    <div class="notif-option-sound-active input-holder">
                                        <label class="notifal-title-label" for="sound-active"><?php esc_html_e('Sound Alert',Notifal_DOMAIN) ?></label>
                                        <input <?php renderHtml::toggle_checkbox(notif::get_notif_settings('sound_active'),'true',''); ?> class="notifal-d-none" type="checkbox" id="sound-active"><label class="notif-switch-input-label" for="sound-active">Toggle</label>
                                    </div>
                                    <?php
                                    $text = esc_html__('Enable a sound alert to play when the Notif appears, making sure users notice new Notifs right away.',Notifal_DOMAIN);
                                    renderHtml::icon_tooltip($text);
                                    ?>
                                </div>

                            </div>
                            <div id="sound-elements" class="<?php renderHtml::toggle_display(notif::get_notif_settings('sound_active'),'true','equal'); ?>">
                                <?php
                                $audios = settings::get_audio_data();
                                $i=1;
                                foreach ($audios as $audio):
                                    ?>
                                    <audio class="notif-audio-src" src="<?php if($i==sizeof($audios)){renderHtml::input_value(notif::get_notif_settings('custom_audio_src'),'');} else echo notif::$notif_audio_path.$audio['value'].'.mp3' ?>"> </audio>
                                <?php $i++; endforeach; ?>
                                <select id="sound-audio" >
                                    <?php
                                    foreach ($audios as $audio):
                                        ?>
                                        <option <?php renderHtml::select_option_value(notif::get_notif_settings('sound_audio'),$audio['value']); ?> value="<?php echo $audio['value']?>">
                                            <?php echo $audio['label']?>
                                        </option>

                                    <?php endforeach; ?>
                                </select>
                                <div id="custom-audio-holder" class="margin-t-10 <?php renderHtml::toggle_display(notif::get_notif_settings('sound_audio'),'custom-audio','equal'); ?>">
                                    <div id="custom-audio">
                                        <a id="select-audio" class="notifal-btn">
                                            <?php esc_html_e('Select/Upload Audio',Notifal_DOMAIN) ?>
                                        </a>
                                    </div>
                                </div>
                                <div id="play-audio" class="margin-t-10">
                                    <a class="notifal-btn">
                                        <?php esc_html_e('Play Audio',Notifal_DOMAIN) ?>
                                    </a>
                                </div>

                                <div id="set-volume-audio" class="margin-t-10">
                                    <label class="volume-slider">
                                        <i class="dashicons dashicons-controls-volumeon"></i>
                                        <input id="audio-volume" type="range" class="level" min="1" max="10" step="1" value="<?php renderHtml::input_value(notif::get_notif_settings('audio_volume'),'3'); ?>">
                                        <i class="dashicons dashicons-controls-volumeoff"></i>
                                    </label>
                                </div>


                            </div>


                        </div>
                        <div class="notif-setting-option-wrapper">
                            <label class="notifal-title-label" for="transition-style"><?php esc_html_e('Notification Display Limit',Notifal_DOMAIN) ?></label>
                            <div class="notifal-unset-gap">
                                <?php
                                ob_start();
                                ?>
                                <select id="notif-counter-type">
                                    <?php
                                    $page_display_options = settings::page_display_options();
                                    foreach ($page_display_options as $options):
                                        ?>
                                        <option <?php renderHtml::select_option_value(notif::get_notif_settings('notif_counter_type'),$options['value']); ?> value="<?php echo $options['value'] ?>"><?php echo $options['label'] ?></option>
                                    <?php endforeach; ?>
                                </select>
                                <?php $page_display=ob_get_clean(); ?>
                                <div class="tooltip-label-holder">
                                    <?php ob_start(); ?>
                                    <input min="1" id="notif-counter" type="number" value="<?php renderHtml::input_value(notif::get_notif_settings('notif_counter'),'5' ) ?>">
                                    <?php $input = ob_get_clean();  ?>
                                    <label><?php printf(esc_html__('Show %s notif per %2s',Notifal_DOMAIN),$input,$page_display); ?></label>
                                    <?php
                                    $text = esc_html__(" Set the number of times the Notif will appear either per page view or per user session. Selecting 'Page' allows the Notif to display up to the specified number on each individual page visit. Choosing 'Session' limits the total number of the Notif shown during the user's entire visit (session) to your site, until they leave or close the browser.",Notifal_DOMAIN);
                                    renderHtml::icon_tooltip($text);
                                    ?>
                                </div>
                            </div>
                        </div>
                        <div class="notif-setting-option-wrapper">
                            <div class="tooltip-label-holder">
                                <label for="custom-css" class="notifal-title-label"> <?php esc_html_e('Custom CSS',Notifal_DOMAIN) ?></label>
                                <?php
                                $text = esc_html__("Add custom CSS to style your notifications. No need for <style> tag, just valid CSS rules.",Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>

                            <textarea id="custom-css"><?php
                                renderHtml::render_backend_notif_text('custom_css','');
                                ?></textarea>
                        </div>
                    </div>
                </div>
            </div>
            <div id="notifal-setting-source" class="notifal-setting notifal-d-none">
                <div class="notif-setting-option-wrapper">
                    <div class="notif-option-input-wrapper">
                        <div class="input-holder">
                            <label class="notifal-title-label" for="woo-orders-active"><?php esc_html_e('WooCommerce Real Orders',Notifal_DOMAIN) ?></label>
                            <input type="checkbox" id="woo-orders-active" <?php renderHtml::toggle_checkbox(notif::get_notif_settings('woo_orders_active'),'true'); ?> ><label class="notif-switch-input-label" for="woo-orders-active">Toggle</label>
                        </div>
                    </div>
                    <div id="woocommerce-source-settings" class="<?php renderHtml::toggle_display(notif::get_notif_settings('woo_orders_active'),'true','equel',true,[0=>1]); ?>">
                        <div class="notif-option-input-wrapper">
                            <div class="tooltip-label-holder">
                                <div class="input-holder">
                                    <label for="display-duplicate-orders"><?php esc_html_e('Display Duplicate Orders',Notifal_DOMAIN) ?></label>
                                    <input type="checkbox" id="display-duplicate-orders" <?php renderHtml::toggle_checkbox(notif::get_notif_settings('display_duplicate_orders'),'true',''); ?> ><label class="notif-switch-input-label" for="display-duplicate-orders">Toggle</label>
                                </div>
                                <?php
                                $text = esc_html__('Enable this option to repeat Notifs once all recent orders within the specified timeframe have been shown. When enabled, previous orders will be cycled through again if more Notifs are needed.',Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>
                        </div>
                        <div class="notif-option-mini-input">
                            <div class="tooltip-label-holder">
                                <?php ob_start() ?>
                                <input id="woo-orders-time" min="1" type="number" value="<?php renderHtml::input_value(notif::get_notif_settings('woo_orders_time'),'6'); ?>">
                                <?php $time_input=ob_get_clean() ?>
                                <label><?php printf(esc_html__('Orders from the last %s days',Notifal_DOMAIN),$time_input); ?></label>
                                <?php
                                $text = esc_html__('Set the number of recent days from which orders will be displayed. For optimal results, if you receive an average of 10 orders daily, limit to the last 2-3 days. For high volume stores (e.g., 50+ orders daily), consider setting to 1 day to maintain relevance',Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>
                        </div>
                        <div class="notif-option-input-wrapper">
                            <div class="input-holder">
                                <label for="first-letter-active"><?php esc_html_e('Show Only the First Letter of the Last Name.',Notifal_DOMAIN) ?></label>
                                <input type="checkbox" id="first-letter-active" <?php renderHtml::toggle_checkbox(notif::get_notif_settings('first_letter_active'),'true',''); ?> ><label class="notif-switch-input-label" for="first-letter-active">Toggle</label>
                            </div>
                        </div>
                        <p><?php esc_html_e('Example: Jason Pitt => Jason P.',Notifal_DOMAIN) ?></p>

                    </div>


                </div>
                <div class="notif-setting-option-wrapper">
                    <div class="notif-option-input-wrapper">
                        <div class="input-holder">
                            <div class="tooltip-label-holder">
                                <label class="notifal-title-label" for="fake-orders-active"><?php esc_html_e('Fake orders',Notifal_DOMAIN) ?></label>
                                <input type="checkbox" <?php renderHtml::toggle_checkbox(notif::get_notif_settings('fake_orders_active'),'true',''); ?> id="fake-orders-active"><label class="notif-switch-input-label" for="fake-orders-active">Toggle</label>
                                <?php
                                $text = esc_html__('Enable this option to create and display Notifs for simulated (fake) orders. These Notifs are helpful for showcasing sales activity, especially in new stores or during low-traffic periods.',Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>
                        </div>
                    </div>
                    <div id="fakeorder-source-settings" class="<?php renderHtml::toggle_display(notif::get_notif_settings('fake_orders_active'),'true','equal',true,[0=>0]); ?>">
                        <div class="notif-option-mini-input">
                            <div class="tooltip-label-holder">
                                <?php ob_start()?>
                                <input id="fake-orders-time" min="1" type="number" value="<?php renderHtml::input_value(notif::get_notif_settings('fake_orders_time'),'8'); ?>">
                                <?php $input=ob_get_clean(); ?>
                                <label><?php esc_html_e('Maximum Age of Fake Orders:',Notifal_DOMAIN) ?><?php printf(esc_html__('%s days ago.',Notifal_DOMAIN),$input) ?></label>
                                <?php
                                $text = esc_html__("Set the maximum age (in days) for the fake orders shown in Notifs. For instance, entering '3' will display fake orders as if they were placed within the last 3 days. The {order_time} tag will reflect this time range.",Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>
                        </div>
                        <div class="notif-option-mini-input">
                            <div class="tooltip-label-holder">
                                <label><?php printf(esc_html__('Maximum Number of Recent Fake Orders',Notifal_DOMAIN) , '{orders_counter}') ?><input id="fake-orders-counter" min="1" type="number" value="<?php renderHtml::input_value(notif::get_notif_settings('fake_orders_counter'),'15'); ?>"></label>
                                <?php
                                $text = esc_html__("Specify the maximum number of fake orders to display in Notifs within a 24-hour period. This setting is used for tags like {order_counter} in your Notif text. For example, if you set this to '15' and create a Notif text like '{order_counter} orders in the last 24 hours!', it will display as '15 orders in the last 24 hours!'",Notifal_DOMAIN);
                                renderHtml::icon_tooltip($text);
                                ?>
                            </div>
                        </div>
                        <div class="notif-setting-option-wrapper">
                            <div class="sub-setting-row">
                                <div class="sub-setting-column">
                                    <div class="tooltip-label-holder">
                                        <label><b>
                                            <?php printf(esc_html__('First Names',Notifal_DOMAIN),'<b>','</b>') ?>
                                        </label></b>
                                        <?php
                                        $text = esc_html__('Add a list of first names for fake orders. These will be randomly paired with surnames to create unique names in each Notif. Please enter at least 30 unique names to ensure fake notifications appear natural and prevent duplicate names from being displayed. Each name + surname is only shown once.',Notifal_DOMAIN);
                                        renderHtml::icon_tooltip($text);
                                        ?>
                                    </div>

                                    <textarea id="fake-orders-fn"><?php renderHtml::input_value(notif::get_notif_settings('fake_orders_fn'),''); ?></textarea>
                                    <p><?php esc_html_e("Press 'Enter' after each entry to add new",Notifal_DOMAIN) ?></p>

                                </div>
                                <div class="sub-setting-column">
                                    <div class="tooltip-label-holder">
                                        <label><b><?php esc_html_e('Surnames',Notifal_DOMAIN); ?></b></label>
                                        <?php
                                        $text = esc_html__('Enter a list of surnames to pair with the first names. Each combination of name and surname will appear only once to create a varied, realistic experience for site visitors.Please enter at least 30 unique surnames to ensure fake notifications appear natural and prevent duplicate surnames from being displayed. Each name + surname is only shown once.',Notifal_DOMAIN);
                                        renderHtml::icon_tooltip($text);
                                        ?>
                                    </div>

                                    <textarea id="fake-orders-ln"><?php renderHtml::input_value(notif::get_notif_settings('fake_orders_ln'),''); ?></textarea>
                                    <p><?php esc_html_e("Press 'Enter' after each entry to add new",Notifal_DOMAIN) ?></p>

                                </div>
                                <div class="sub-setting-column">
                                    <div class="tooltip-label-holder">
                                        <label><b><?php esc_html_e('Cities',Notifal_DOMAIN); ?></b></label>
                                        <?php
                                        $text = esc_html__("Enter city names to show as the origin of fake orders in Notifs. This adds a localized and authentic touch to each Notif.",Notifal_DOMAIN);
                                        renderHtml::icon_tooltip($text);
                                        ?>
                                    </div>
                                    <textarea id="fake-orders-cities"><?php renderHtml::input_value(notif::get_notif_settings('fake_orders_cities'),''); ?></textarea>
                                    <p><?php esc_html_e('Press “Enter” key at the end of each line',Notifal_DOMAIN) ?></p>

                                </div>
                            </div>

                        </div>


                    </div>

                </div>
            </div>
            <div id="notifal-setting-conditions" class="notifal-setting notifal-d-none">
                <div class="notif-setting-option-wrapper">
                    <div class="tooltip-label-holder">
                        <label class="notifal-title-label" for="page-type"><?php esc_html_e('Pages Visibility',Notifal_DOMAIN) ?></label>
                        <?php
                        $text = __('Select where the Notifs will be displayed across your site, whether on all pages, with exclusions, or only specific pages.
                                    All Pages: Display the Notif on all pages of your site.
                                    All Pages Except: Show the Notif on all pages except for the ones you specify.
                                    Specific Pages: Show the Notif only on selected pages.
                                    ',Notifal_DOMAIN);
                        renderHtml::icon_tooltip($text);
                        ?>
                    </div>
                    <select id="page-type">
                        <?php
                        $conditions =  settings::get_page_conditions();
                        foreach ($conditions as $condition):
                        $is_pro=!empty($condition['Pro']) && !maintenance::is_pro_active();

                        ?>
                        <option <?php if($is_pro) echo 'disabled' ?> class="<?php if($is_pro) echo 'notifal-pro-text' ?>" <?php renderHtml::select_option_value(notif::get_notif_conditions(),$condition['value']) ?> value="<?php echo $condition['value'] ?>"><?php echo $condition['label']; if($is_pro) echo '(Pro version)'?></option>
                        <?php endforeach; ?>
                    </select>
                </div>
                <?php do_action('after_pages_conditions') ?>
            </div>
            <div id="notifal-setting-save" >
                <button id="save-notif">
                    <?php esc_html_e('Save',Notifal_DOMAIN) ?>
                </button>
                <div class="notifal-loader notifal-d-none"></div>

            </div>
            <div id="notifal-setting-message" class="notifal-d-none">
                <?php esc_html_e('Try again later.',Notifal_DOMAIN) ?>
            </div>
        </div>
    </div>
</div>

