<?php
use Notifal\plugin;
use Notifal\notif as notif;
use Notifal\renderHtml as renderHtml;
use Notifal\notif\settings as settings;
use Notifal\maintenance as maintenance;
/**
 * Template: Order notification template 1
 *
 */
$template__id = '';
if(is_admin()){
    if(maintenance::is_woocommerce_active()){
        $sample_product_data = plugin::get_instance()->woocommerce->get_random_product();
    }
    $notif='';
}else{
    $template__id = '#' . $template_id;
}
?>

<style>
    @media (max-width:575px){
        <?php echo $template__id ?> .notifal-pulse-temp1{
            width: 95%;
        }
    }
    @media (min-width:576px){
        <?php echo $template__id ?> .notifal-pulse-temp1{
            width: 350px;
        }
    }

    

    <?php echo $template__id ?> .notifal-pulse-temp1{
        position: relative;
        background-color: <?php notif::set_notif_color('background_color','#F6F6F6',$notif) ?>;
        border: 2px solid <?php notif::set_notif_color('color2','#020F84',$notif) ?>;
        border-radius: 20px;
        padding: 7px;
        font-family: sans-serif;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 p{
        font-size: 13px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-pulse-details{
        display: grid;
        grid-template-areas: 'img img details details details details details close';
        grid-gap: 5px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-pulse-details img{
        border-radius: 16px;
        height:auto;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-pulse-details span{
        font-weight: bold;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .action-button-parent {
        padding: 5px 20px;
        color:<?php notif::set_notif_color('action_btn_text_color','#fff',$notif) ?>;
        background-color:<?php notif::set_notif_color('action_btn_background_color','#020F84',$notif) ?>;
        border-radius: 7px;
        cursor: pointer;
        max-width: fit-content;
        display: inline;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .action-button-parent * {
        color:<?php notif::set_notif_color('action_btn_text_color','#fff',$notif) ?>;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-pulse-details p{
        color : <?php notif::set_notif_color('text_color','#6f6f6f',$notif) ?>;

        margin: 5px 0;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-footer{
        display: flex;
        justify-content: space-between;
        margin-left: 6px;
        margin-right: 6px;
        margin-top: 3px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-footer p{
        margin: 3px 0;
        font-size: 13px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-pulse-data{
        display: flex;
        flex-direction: column;
        justify-content: space-between;
        grid-area: details;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-pulse-img{
        grid-area: img;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .notifal-close{
        cursor: pointer;
        color : <?php notif::set_notif_color('close_icon_color','#3c434a',$notif) ?>;
        grid-area: close;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .second-additional-info,<?php echo $template__id ?> .notifal-pulse-temp1 .second-additional-info *{
        color: <?php notif::set_notif_color('second_additional_info_text_color','#6f6f6f',$notif) ?>;
        text-align: left;
    }
    <?php echo $template__id ?> .notifal-pulse-temp1 .first-additional-info , <?php echo $template__id ?> .notifal-pulse-temp1 .first-additional-info *{
        color: <?php notif::set_notif_color('first_additional_info_text_color','#6f6f6f',$notif) ?>;
        text-align: left;
    }

    <?php
    echo notif::set_notif_template_styles($notif);
 ?>
</style>
<div class="notifal-pulse-temp1 notifal-pulse">
    <div class="notifal-pulse-details">
        <div class="notifal-pulse-img <?php renderHtml::toggle_display(notif::get_notif_settings('product_image',false,$notif),'true','equal',true,[0=>1]); ?>">
            <?php if(is_admin()) echo $sample_product_data[0]['image'] ?? '' ?>
        </div>
        <div class="notifal-pulse-data">
            <p class="notifal-main-text">
                <?php
                $default_main_notif_text = settings::get_default_notif_text();

                renderHtml::render_backend_notif_text('custom_main_text',$default_main_notif_text,false,$notif);
                ?>
            </p>
            <p class="action-button-parent <?php renderHtml::toggle_display(notif::get_notif_settings('action_button',false,$notif),'true','equal',true,[0=>1]); ?>">
                <?php
                $default_action_btn_text =settings::get_default_notif_text('action_button');
                renderHtml::render_backend_notif_text('action_button_text',$default_action_btn_text,false,$notif);
                ?>
            </p>
        </div>
        <span class="dashicons dashicons-no-alt notifal-close <?php renderHtml::toggle_display(notif::get_notif_settings('allow_close',false,$notif),'true','equal',true,[0=>1]); ?>"></span>
    </div>

    <div class="notifal-footer">
        <p class="first-additional-info <?php renderHtml::toggle_display(notif::get_notif_settings('first_additional_info',false,$notif),'true','equal',true,[0=>1]); ?>">
            <?php
            $default_time_text =settings::get_default_notif_text('first_additional_info');
            renderHtml::render_backend_notif_text('first_additional_info_text',$default_time_text,false,$notif);
            ?>
        </p>
        <p class="second-additional-info <?php renderHtml::toggle_display(notif::get_notif_settings('second_additional_info',false,$notif),'true','equal',true,[0=>1]); ?>">
            <?php
            $default_stock_text = settings::get_default_notif_text('second_additional_info');
            renderHtml::render_backend_notif_text('second_additional_info_text',$default_stock_text,false,$notif);
            ?>
        </p>
    </div>
</div>
