<?php
use Notifal\notif\settings;
use Notifal\plugin;
use Notifal\notif as notif;
use Notifal\maintenance as maintenance;
use Notifal\renderHtml as renderHtml;
/**
 * Template: Order notification template 3
 *
 */
$template__id = '';
if(is_admin()){
    if(maintenance::is_woocommerce_active()){
        $sample_product_data = plugin::get_instance()->woocommerce->get_random_product();
    }
    $notif='';
}else{
    $template__id = '#' . $template_id;
}
?>
<style>

@media (max-width:575px){
        <?php echo $template__id ?> .notifal-pulse-temp3{
            width: 95%;
        }
    }
    @media (min-width:576px){
        <?php echo $template__id ?> .notifal-pulse-temp3{
            width: 350px;
        }
    }
    
    <?php echo $template__id ?> .notifal-pulse-temp3{
        position: relative;
        font-family: sans-serif;
        line-height: 1.6;
        background-color: <?php notif::set_notif_color('background_color','#fff',$notif) ?>;
        border: 2px solid <?php notif::set_notif_color('color2','#2454ff',$notif) ?>;
        border-radius: 20px;
        padding: 7px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 p{
        font-size: 13px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-temp3-header{
        margin: unset;
        display: flex;
        flex-direction: row;
        justify-content: space-between;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-temp3-header p{
        margin: 0 30px 0 0;
        font-size: 13px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-pulse-details{
        display: grid;
        grid-template-areas: 'img img details details details details details details details';
        grid-gap: 5px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-pulse-img{
        grid-area: img;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-pulse-details img{
        border-radius: 16px;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-pulse-details span{
        font-weight: bold;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-pulse-data{
        display: flex;
        flex-direction: column;
        row-gap: 7px;
        grid-area: details;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .action-button-parent  {
        padding: 5px 20px;f;
        color:<?php notif::set_notif_color('action_btn_text_color',' #fff',$notif) ?>;
        background-color:<?php notif::set_notif_color('action_btn_background_color','#2454ff',$notif) ?>;
        border-radius: 7px;
        cursor: pointer;
        max-width: fit-content;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .action-button-parent *{
        color:<?php notif::set_notif_color('action_btn_text_color',' #fff',$notif) ?>;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 p.notifal-main-text{
        margin-top: 6px;
        margin-bottom: 0;
        color: <?php notif::set_notif_color('text_color','#6f6f6f',$notif) ?>

    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-footer p{
        font-size: 13px;
        margin: 5px 0 0;
        text-align: center;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-footer a{
        font-weight: bold;
        cursor: pointer;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .notifal-close{
        position: absolute;
        right: 6px;
        top: 6px;
        cursor: pointer;
        color:<?php notif::set_notif_color('close_icon_color','#3c434a',$notif) ?>
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .second-additional-info, <?php echo $template__id ?> .notifal-pulse-temp3 .second-additional-info *{
        color: <?php notif::set_notif_color('second_additional_info_text_color','#6f6f6f',$notif); ?>;
        text-align: left;
    }
    <?php echo $template__id ?> .notifal-pulse-temp3 .first-additional-info, <?php echo $template__id ?> .notifal-pulse-temp3 .first-additional-info *{
        color: <?php notif::set_notif_color('first_additional_info_text_color','#6f6f6f',$notif) ?>;
        text-align: left;
    }
    <?php

echo notif::set_notif_template_styles($notif);
     ?>
</style>
<div class="notifal-pulse-temp3 notifal-pulse">
    <div class="notifal-temp3-content">
        <div class="notifal-temp3-header">
            <p class="first-additional-info <?php renderHtml::toggle_display(notif::get_notif_settings('first_additional_info',false,$notif),'true','equal',true,[0=>1]); ?>">
                <?php
                $default_time_text =settings::get_default_notif_text('first_additional_info');
                renderHtml::render_backend_notif_text('first_additional_info_text',$default_time_text,false,$notif);
                ?>
            </p>
            <p class="second-additional-info <?php renderHtml::toggle_display(notif::get_notif_settings('second_additional_info',false,$notif),'true','equal',true,[0=>1]); ?>">
                <?php
                $default_stock_text = settings::get_default_notif_text('second_additional_info');
                renderHtml::render_backend_notif_text('second_additional_info_text',$default_stock_text,false,$notif);
                ?>
            </p>
            <span class="dashicons dashicons-no-alt notifal-close <?php renderHtml::toggle_display(notif::get_notif_settings('allow_close',false,$notif),'true','equal',true,[0=>1]); ?>"></span>
        </div>
        <div class="notifal-pulse-details">
            <div class="notifal-pulse-img <?php renderHtml::toggle_display(notif::get_notif_settings('product_image',false,$notif),'true','equal',true,[0=>1]); ?>">
                <?php if(is_admin()) echo $sample_product_data[0]['image'] ?? '' ?>
            </div>
            <div class="notifal-pulse-data">
                <p class="notifal-main-text">
                    <?php
                    $default_main_notif_text =settings::get_default_notif_text();
                    renderHtml::render_backend_notif_text('custom_main_text',$default_main_notif_text,false,$notif);
                    ?>
                </p>
                <p class="action-button-parent <?php renderHtml::toggle_display(notif::get_notif_settings('action_button',false,$notif),'true','equal',true,[0=>1]); ?>">
                    <?php
                    $default_action_btn_text =settings::get_default_notif_text('action_button');
                    renderHtml::render_backend_notif_text('action_button_text',$default_action_btn_text,false,$notif);
                    ?>
                </p>
            </div>
        </div>
    </div>
    <div class="notifal-footer">

    </div>
</div>